(* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *)

exception Error of string * int
exception Closed of string

(* Give the exceptions names so that they can be raised from the C code. *)
let () =
  Callback.register_exception "nbd_internal_ocaml_error" (Error ("", 0));
  Callback.register_exception "nbd_internal_ocaml_closed" (Closed "")

module TLS = struct
  type t =
  | DISABLE
  | ALLOW
  | REQUIRE
end

module CMD_FLAG = struct
  type t =
  | FUA
  | NO_HOLE
  | DF
  | REQ_ONE
end

let aio_direction_read = 1_l
let aio_direction_write = 2_l
let aio_direction_both = 3_l
let read_data = 1_l
let read_hole = 2_l
let read_error = 3_l
let namespace_base = "base:"
let context_base_allocation = "base:allocation"
let state_hole = 1_l
let state_zero = 2_l

module Buffer = struct
  type t
  external alloc : int -> t = "nbd_internal_ocaml_buffer_alloc"
  external to_bytes : t -> bytes = "nbd_internal_ocaml_buffer_to_bytes"
  external of_bytes : bytes -> t = "nbd_internal_ocaml_buffer_of_bytes"
  external size : t -> int = "nbd_internal_ocaml_buffer_size"
end

type t

external create : unit -> t = "nbd_internal_ocaml_nbd_create"
external close : t -> unit = "nbd_internal_ocaml_nbd_close"

external set_debug : t -> bool -> unit
    = "nbd_internal_ocaml_nbd_set_debug"
external get_debug : t -> bool
    = "nbd_internal_ocaml_nbd_get_debug"
external set_debug_callback : t -> (string -> string -> int) -> unit
    = "nbd_internal_ocaml_nbd_set_debug_callback"
external clear_debug_callback : t -> unit
    = "nbd_internal_ocaml_nbd_clear_debug_callback"
external set_handle_name : t -> string -> unit
    = "nbd_internal_ocaml_nbd_set_handle_name"
external get_handle_name : t -> string
    = "nbd_internal_ocaml_nbd_get_handle_name"
external set_export_name : t -> string -> unit
    = "nbd_internal_ocaml_nbd_set_export_name"
external get_export_name : t -> string
    = "nbd_internal_ocaml_nbd_get_export_name"
external set_tls : t -> TLS.t -> unit
    = "nbd_internal_ocaml_nbd_set_tls"
external get_tls : t -> int
    = "nbd_internal_ocaml_nbd_get_tls"
external set_tls_certificates : t -> string -> unit
    = "nbd_internal_ocaml_nbd_set_tls_certificates"
external set_tls_verify_peer : t -> bool -> unit
    = "nbd_internal_ocaml_nbd_set_tls_verify_peer"
external get_tls_verify_peer : t -> bool
    = "nbd_internal_ocaml_nbd_get_tls_verify_peer"
external set_tls_username : t -> string -> unit
    = "nbd_internal_ocaml_nbd_set_tls_username"
external get_tls_username : t -> string
    = "nbd_internal_ocaml_nbd_get_tls_username"
external set_tls_psk_file : t -> string -> unit
    = "nbd_internal_ocaml_nbd_set_tls_psk_file"
external add_meta_context : t -> string -> unit
    = "nbd_internal_ocaml_nbd_add_meta_context"
external connect_uri : t -> string -> unit
    = "nbd_internal_ocaml_nbd_connect_uri"
external connect_unix : t -> string -> unit
    = "nbd_internal_ocaml_nbd_connect_unix"
external connect_tcp : t -> string -> string -> unit
    = "nbd_internal_ocaml_nbd_connect_tcp"
external connect_command : t -> string list -> unit
    = "nbd_internal_ocaml_nbd_connect_command"
external is_read_only : t -> bool
    = "nbd_internal_ocaml_nbd_is_read_only"
external can_flush : t -> bool
    = "nbd_internal_ocaml_nbd_can_flush"
external can_fua : t -> bool
    = "nbd_internal_ocaml_nbd_can_fua"
external is_rotational : t -> bool
    = "nbd_internal_ocaml_nbd_is_rotational"
external can_trim : t -> bool
    = "nbd_internal_ocaml_nbd_can_trim"
external can_zero : t -> bool
    = "nbd_internal_ocaml_nbd_can_zero"
external can_df : t -> bool
    = "nbd_internal_ocaml_nbd_can_df"
external can_multi_conn : t -> bool
    = "nbd_internal_ocaml_nbd_can_multi_conn"
external can_cache : t -> bool
    = "nbd_internal_ocaml_nbd_can_cache"
external can_meta_context : t -> string -> bool
    = "nbd_internal_ocaml_nbd_can_meta_context"
external get_size : t -> int64
    = "nbd_internal_ocaml_nbd_get_size"
external pread : ?flags:CMD_FLAG.t list -> t -> bytes -> int64 -> unit
    = "nbd_internal_ocaml_nbd_pread"
external pread_structured : ?flags:CMD_FLAG.t list -> t -> bytes -> int64 -> (bytes -> int64 -> int -> int ref -> int) -> unit
    = "nbd_internal_ocaml_nbd_pread_structured"
external pwrite : ?flags:CMD_FLAG.t list -> t -> bytes -> int64 -> unit
    = "nbd_internal_ocaml_nbd_pwrite"
external shutdown : ?flags:CMD_FLAG.t list -> t -> unit
    = "nbd_internal_ocaml_nbd_shutdown"
external flush : ?flags:CMD_FLAG.t list -> t -> unit
    = "nbd_internal_ocaml_nbd_flush"
external trim : ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> unit
    = "nbd_internal_ocaml_nbd_trim"
external cache : ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> unit
    = "nbd_internal_ocaml_nbd_cache"
external zero : ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> unit
    = "nbd_internal_ocaml_nbd_zero"
external block_status : ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> (string -> int64 -> int32 array -> int ref -> int) -> unit
    = "nbd_internal_ocaml_nbd_block_status"
external poll : t -> int -> int
    = "nbd_internal_ocaml_nbd_poll"
external aio_connect : t -> string -> unit
    = "nbd_internal_ocaml_nbd_aio_connect"
external aio_connect_uri : t -> string -> unit
    = "nbd_internal_ocaml_nbd_aio_connect_uri"
external aio_connect_unix : t -> string -> unit
    = "nbd_internal_ocaml_nbd_aio_connect_unix"
external aio_connect_tcp : t -> string -> string -> unit
    = "nbd_internal_ocaml_nbd_aio_connect_tcp"
external aio_connect_command : t -> string list -> unit
    = "nbd_internal_ocaml_nbd_aio_connect_command"
external aio_pread : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> Buffer.t -> int64 -> int64
    = "nbd_internal_ocaml_nbd_aio_pread"
external aio_pread_structured : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> Buffer.t -> int64 -> (bytes -> int64 -> int -> int ref -> int) -> int64
    = "nbd_internal_ocaml_nbd_aio_pread_structured_byte" "nbd_internal_ocaml_nbd_aio_pread_structured"
external aio_pwrite : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> Buffer.t -> int64 -> int64
    = "nbd_internal_ocaml_nbd_aio_pwrite"
external aio_disconnect : ?flags:CMD_FLAG.t list -> t -> unit
    = "nbd_internal_ocaml_nbd_aio_disconnect"
external aio_flush : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> int64
    = "nbd_internal_ocaml_nbd_aio_flush"
external aio_trim : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> int64
    = "nbd_internal_ocaml_nbd_aio_trim"
external aio_cache : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> int64
    = "nbd_internal_ocaml_nbd_aio_cache"
external aio_zero : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> int64
    = "nbd_internal_ocaml_nbd_aio_zero"
external aio_block_status : ?completion:(int ref -> int) -> ?flags:CMD_FLAG.t list -> t -> int64 -> int64 -> (string -> int64 -> int32 array -> int ref -> int) -> int64
    = "nbd_internal_ocaml_nbd_aio_block_status_byte" "nbd_internal_ocaml_nbd_aio_block_status"
external aio_get_fd : t -> Unix.file_descr
    = "nbd_internal_ocaml_nbd_aio_get_fd"
external aio_get_direction : t -> int
    = "nbd_internal_ocaml_nbd_aio_get_direction"
external aio_notify_read : t -> unit
    = "nbd_internal_ocaml_nbd_aio_notify_read"
external aio_notify_write : t -> unit
    = "nbd_internal_ocaml_nbd_aio_notify_write"
external aio_is_created : t -> bool
    = "nbd_internal_ocaml_nbd_aio_is_created"
external aio_is_connecting : t -> bool
    = "nbd_internal_ocaml_nbd_aio_is_connecting"
external aio_is_ready : t -> bool
    = "nbd_internal_ocaml_nbd_aio_is_ready"
external aio_is_processing : t -> bool
    = "nbd_internal_ocaml_nbd_aio_is_processing"
external aio_is_dead : t -> bool
    = "nbd_internal_ocaml_nbd_aio_is_dead"
external aio_is_closed : t -> bool
    = "nbd_internal_ocaml_nbd_aio_is_closed"
external aio_command_completed : t -> int64 -> bool
    = "nbd_internal_ocaml_nbd_aio_command_completed"
external aio_peek_command_completed : t -> int64
    = "nbd_internal_ocaml_nbd_aio_peek_command_completed"
external aio_in_flight : t -> int
    = "nbd_internal_ocaml_nbd_aio_in_flight"
external connection_state : t -> string
    = "nbd_internal_ocaml_nbd_connection_state"
external get_package_name : t -> string
    = "nbd_internal_ocaml_nbd_get_package_name"
external get_version : t -> string
    = "nbd_internal_ocaml_nbd_get_version"
external kill_subprocess : t -> int -> unit
    = "nbd_internal_ocaml_nbd_kill_subprocess"
external supports_tls : t -> bool
    = "nbd_internal_ocaml_nbd_supports_tls"
external supports_uri : t -> bool
    = "nbd_internal_ocaml_nbd_supports_uri"
