/* NBD client library in userspace
 * WARNING: THIS FILE IS GENERATED FROM
 * generator/generator generator/states*.c
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#line 1 "generator/states-connect.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machines related to connecting to the server. */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

/* Disable Nagle's algorithm on the socket, but don't fail. */
static void
disable_nagle (int sock)
{
  const int flag = 1;

  setsockopt (sock, IPPROTO_TCP, TCP_NODELAY, &flag, sizeof flag);
}


#line 1 "generator/states-issue-command.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for issuing commands (requests) to the server. */


#line 1 "generator/states-magic.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for parsing the initial magic number from the server. */


#line 1 "generator/states-newstyle-opt-export-name.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for ending newstyle handshake with NBD_OPT_EXPORT_NAME. */


#line 1 "generator/states-newstyle-opt-go.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for ending fixed newstyle handshake with NBD_OPT_GO. */


#line 1 "generator/states-newstyle-opt-set-meta-context.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for negotiating NBD_OPT_SET_META_CONTEXT. */


#line 1 "generator/states-newstyle-opt-starttls.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for sending NBD_OPT_STARTTLS. */


#line 1 "generator/states-newstyle-opt-structured-reply.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for negotiating NBD_OPT_STRUCTURED_REPLY. */


#line 1 "generator/states-newstyle.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <assert.h>

#include "internal.h"

/* Common code for parsing a reply to NBD_OPT_*. */
static int
prepare_for_reply_payload (struct nbd_handle *h, uint32_t opt)
{
  const size_t maxpayload = sizeof h->sbuf.or.payload;
  uint64_t magic;
  uint32_t option;
  uint32_t reply;
  uint32_t len;

  magic = be64toh (h->sbuf.or.option_reply.magic);
  option = be32toh (h->sbuf.or.option_reply.option);
  reply = be32toh (h->sbuf.or.option_reply.reply);
  len = be32toh (h->sbuf.or.option_reply.replylen);
  if (magic != NBD_REP_MAGIC || option != opt) {
    set_error (0, "handshake: invalid option reply magic or option");
    return -1;
  }

  /* Validate lengths that the state machine depends on. */
  switch (reply) {
  case NBD_REP_ACK:
    if (len != 0) {
      set_error (0, "handshake: invalid NBD_REP_ACK option reply length");
      return -1;
    }
    break;
  case NBD_REP_INFO:
    /* Can't enforce an upper bound, thanks to unknown INFOs */
    if (len < sizeof h->sbuf.or.payload.export.info) {
      set_error (0, "handshake: NBD_REP_INFO reply length too small");
      return -1;
    }
    break;
  case NBD_REP_META_CONTEXT:
    if (len <= sizeof h->sbuf.or.payload.context.context ||
        len > sizeof h->sbuf.or.payload.context) {
      set_error (0, "handshake: invalid NBD_REP_META_CONTEXT reply length");
      return -1;
    }
    break;
  }

  /* Read the following payload if it is short enough to fit in the
   * static buffer.  If it's too long, skip it.
   */
  len = be32toh (h->sbuf.or.option_reply.replylen);
  if (len > MAX_REQUEST_SIZE) {
    set_error (0, "handshake: invalid option reply length");
    return -1;
  }
  else if (len <= maxpayload)
    h->rbuf = &h->sbuf.or.payload;
  else
    h->rbuf = NULL;
  h->rlen = len;
  return 0;
}

/* Check an unexpected server reply. If it is an error, log any
 * message from the server and return 0; otherwise, return -1.
 */
static int
handle_reply_error (struct nbd_handle *h)
{
  uint32_t len;
  uint32_t reply;

  len = be32toh (h->sbuf.or.option_reply.replylen);
  reply = be32toh (h->sbuf.or.option_reply.reply);
  if (!NBD_REP_IS_ERR (reply)) {
    set_error (0, "handshake: unexpected option reply type %d", reply);
    return -1;
  }

  assert (NBD_MAX_STRING < sizeof h->sbuf.or.payload);
  if (len > NBD_MAX_STRING) {
    set_error (0, "handshake: option error string too long");
    return -1;
  }

  if (len > 0)
    debug (h, "handshake: server error message: %.*s", (int) len,
           h->sbuf.or.payload.err_msg);

  return 0;
}

/* State machine for parsing the fixed newstyle handshake. */


#line 1 "generator/states-oldstyle.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for parsing the oldstyle handshake. */


#line 1 "generator/states-reply-simple.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for parsing simple replies from the server. */


#line 1 "generator/states-reply-structured.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* State machine for parsing structured replies from the server. */

/*----- End of prologue. -----*/


#line 1 "generator/states-reply.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include <assert.h>

/* State machine for receiving reply messages from the server.
 *
 * Note that we never block while in this sub-group. If there is
 * insufficient data to finish parsing a reply, requiring us to block
 * until POLLIN, we instead track where in the state machine we left
 * off, then return to READY to actually block. Then, on entry to
 * REPLY.START, we can tell if this is the start of a new reply (rlen
 * is 0, stay put), a continuation of the preamble (reply_cmd is NULL,
 * resume with RECV_REPLY), or a continuation from any other location
 * (reply_cmd contains the state to jump to).
 */

static void
save_reply_state (struct nbd_handle *h)
{
  assert (h->reply_cmd);
  assert (h->rlen);
  h->reply_cmd->state = get_next_state (h);
}

/*----- End of prologue. -----*/


#line 1 "generator/states.c"
/* nbd client library in userspace: state machine
 * Copyright (C) 2013-2019 Red Hat Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/* This isn't "real" C code.  It is read by the generator, parsed, and
 * put into generated files.  Also it won't make much sense unless you
 * read the generator state machine and documentation in
 * generator/generator first.
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>

#include "internal.h"

/* Uncomment this to dump received protocol packets to stderr. */
/*#define DUMP_PACKETS 1*/

static int
recv_into_rbuf (struct nbd_handle *h)
{
  ssize_t r;
  char buf[BUFSIZ];
  void *rbuf;
  size_t rlen;

  if (h->rlen == 0)
    return 0;                   /* move to next state */

  /* As a special case h->rbuf is allowed to be NULL, meaning
   * throw away the data.
   */
  if (h->rbuf) {
    rbuf = h->rbuf;
    rlen = h->rlen;
  }
  else {
    rbuf = &buf;
    rlen = h->rlen > sizeof buf ? sizeof buf : h->rlen;
  }

  r = h->sock->ops->recv (h, h->sock, rbuf, rlen);
  if (r == -1) {
    if (errno == EAGAIN || errno == EWOULDBLOCK)
      return 1;                 /* more data */
    /* sock->ops->recv called set_error already. */
    return -1;
  }
  if (r == 0) {
    set_error (0, "recv: server disconnected unexpectedly");
    return -1;
  }
#ifdef DUMP_PACKETS
  if (h->rbuf != NULL)
    nbd_internal_hexdump (h->rbuf, r, stderr);
#endif
  if (h->rbuf)
    h->rbuf += r;
  h->rlen -= r;
  if (h->rlen == 0)
    return 0;                   /* move to next state */
  else
    return 1;                   /* more data */
}

static int
send_from_wbuf (struct nbd_handle *h)
{
  ssize_t r;

  if (h->wlen == 0)
    goto next_state;
  r = h->sock->ops->send (h, h->sock, h->wbuf, h->wlen, h->wflags);
  if (r == -1) {
    if (errno == EAGAIN || errno == EWOULDBLOCK)
      return 1;                 /* more data */
    /* sock->ops->send called set_error already. */
    return -1;
  }
  h->wbuf += r;
  h->wlen -= r;
  if (h->wlen == 0)
    goto next_state;
  else
    return 1;                   /* more data */

 next_state:
  h->wflags = 0;                /* reset this when moving to next state */
  return 0;                     /* move to next state */
}

/* Forcefully fail any remaining in-flight commands in list */
void abort_commands (struct nbd_handle *h,
                     struct command **list)
{
  struct command *next, *cmd;

  for (cmd = *list, *list = NULL; cmd != NULL; cmd = next) {
    bool retire = cmd->type == NBD_CMD_DISC;

    next = cmd->next;
    if (CALLBACK_IS_NOT_NULL (cmd->cb.completion)) {
      int error = cmd->error ? cmd->error : ENOTCONN;
      int r;

      assert (cmd->type != NBD_CMD_DISC);
      r = CALL_CALLBACK (cmd->cb.completion, &error);
      switch (r) {
      case -1:
        if (error)
          cmd->error = error;
        break;
      case 1:
        retire = true;
        break;
      }
    }
    if (cmd->error == 0)
      cmd->error = ENOTCONN;
    if (retire)
      nbd_internal_retire_and_free_command (cmd);
    else {
      cmd->next = NULL;
      if (h->cmds_done_tail)
        h->cmds_done_tail->next = cmd;
      else {
        assert (h->cmds_done == NULL);
        h->cmds_done = cmd;
      }
      h->cmds_done_tail = cmd;
    }
  }
}

/*----- End of prologue. -----*/




#define SET_NEXT_STATE(s) (*blocked = false, *next_state = (s))
#define SET_NEXT_STATE_AND_BLOCK(s) (*next_state = (s))

/* START: Handle after being initially created */
static int
_enter_STATE_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
  return 0;
}

static int
enter_STATE_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_START;

  r = _enter_STATE_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT.START: Initial call to connect(2) on the socket */
static int
_enter_STATE_CONNECT_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 50 "generator/states-connect.c"

  int fd;

  assert (!h->sock);
  fd = socket (AF_UNIX, SOCK_STREAM|SOCK_NONBLOCK|SOCK_CLOEXEC, 0);
  if (fd == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (errno, "socket");
    return 0;
  }
  h->sock = nbd_internal_socket_create (fd);
  if (!h->sock) {
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }

  disable_nagle (fd);

  if (connect (fd, (struct sockaddr *) &h->connaddr,
               h->connaddrlen) == -1) {
    if (errno != EINPROGRESS) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (errno, "connect");
      return 0;
    }
  }
  return 0;

}

static int
enter_STATE_CONNECT_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_START;

  r = _enter_STATE_CONNECT_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT.CONNECTING: Connecting to the remote server */
static int
_enter_STATE_CONNECT_CONNECTING (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 78 "generator/states-connect.c"

  int status;
  socklen_t len = sizeof status;

  if (getsockopt (h->sock->ops->get_fd (h->sock),
                  SOL_SOCKET, SO_ERROR, &status, &len) == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (errno, "getsockopt: SO_ERROR");
    return 0;
  }
  /* This checks the status of the original connect call. */
  if (status == 0) {
    SET_NEXT_STATE (STATE_MAGIC_START);
    return 0;
  }
  else {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (status, "connect");
    return 0;
  }

}

static int
enter_STATE_CONNECT_CONNECTING (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_CONNECTING;

  r = _enter_STATE_CONNECT_CONNECTING (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT.CONNECTING",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT_UNIX.START: Connect to a Unix domain socket */
static int
_enter_STATE_CONNECT_UNIX_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 99 "generator/states-connect.c"

  struct sockaddr_un sun = { .sun_family = AF_UNIX };
  socklen_t len;
  size_t namelen;

  assert (h->unixsocket != NULL);

  namelen = strlen (h->unixsocket);
  if (namelen > sizeof sun.sun_path) {
    set_error (ENAMETOOLONG, "socket name too long: %s", h->unixsocket);
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }
  memcpy (sun.sun_path, h->unixsocket, namelen);
  len = sizeof sun;

  memcpy (&h->connaddr, &sun, len);
  h->connaddrlen = len;
  SET_NEXT_STATE (STATE_CONNECT_START);
  return 0;

}

static int
enter_STATE_CONNECT_UNIX_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_UNIX_START;

  r = _enter_STATE_CONNECT_UNIX_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT_UNIX.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT_TCP.START: Connect to a remote TCP server */
static int
_enter_STATE_CONNECT_TCP_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 120 "generator/states-connect.c"

  int r;

  assert (h->hostname != NULL);
  assert (h->port != NULL);

  if (h->result) {
    freeaddrinfo (h->result);
    h->result = NULL;
  }

  memset (&h->hints, 0, sizeof h->hints);
  h->hints.ai_family = AF_UNSPEC;
  h->hints.ai_socktype = SOCK_STREAM;
  h->hints.ai_flags = 0;
  h->hints.ai_protocol = 0;

  /* XXX Unfortunately getaddrinfo blocks.  getaddrinfo_a isn't
   * portable and in any case isn't an alternative because it can't be
   * integrated into a main loop.
   */
  r = getaddrinfo (h->hostname, h->port, &h->hints, &h->result);
  if (r != 0) {
    SET_NEXT_STATE (STATE_START);
    set_error (0, "getaddrinfo: %s:%s: %s",
               h->hostname, h->port, gai_strerror (r));
    return -1;
  }

  h->rp = h->result;
  SET_NEXT_STATE (STATE_CONNECT_TCP_CONNECT);
  return 0;

}

static int
enter_STATE_CONNECT_TCP_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_TCP_START;

  r = _enter_STATE_CONNECT_TCP_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT_TCP.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT_TCP.CONNECT: Initial call to connect(2) on a TCP socket */
static int
_enter_STATE_CONNECT_TCP_CONNECT (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 153 "generator/states-connect.c"

  int fd;

  assert (!h->sock);

  if (h->rp == NULL) {
    /* We tried all the results from getaddrinfo without success.
     * Save errno from most recent connect(2) call. XXX
     */
    SET_NEXT_STATE (STATE_START);
    set_error (0, "connect: %s:%s: could not connect to remote host",
               h->hostname, h->port);
    return -1;
  }

  fd = socket (h->rp->ai_family,
               h->rp->ai_socktype|SOCK_NONBLOCK|SOCK_CLOEXEC,
               h->rp->ai_protocol);
  if (fd == -1) {
    SET_NEXT_STATE (STATE_CONNECT_TCP_NEXT_ADDRESS);
    return 0;
  }
  h->sock = nbd_internal_socket_create (fd);
  if (!h->sock) {
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }

  disable_nagle (fd);

  if (connect (fd, h->rp->ai_addr, h->rp->ai_addrlen) == -1) {
    if (errno != EINPROGRESS) {
      SET_NEXT_STATE (STATE_CONNECT_TCP_NEXT_ADDRESS);
      return 0;
    }
  }

  SET_NEXT_STATE (STATE_CONNECT_TCP_CONNECTING);
  return 0;

}

static int
enter_STATE_CONNECT_TCP_CONNECT (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_TCP_CONNECT;

  r = _enter_STATE_CONNECT_TCP_CONNECT (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT_TCP.CONNECT",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT_TCP.CONNECTING: Connecting to the remote server over a TCP socket */
static int
_enter_STATE_CONNECT_TCP_CONNECTING (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 193 "generator/states-connect.c"

  int status;
  socklen_t len = sizeof status;

  if (getsockopt (h->sock->ops->get_fd (h->sock),
                  SOL_SOCKET, SO_ERROR, &status, &len) == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (errno, "getsockopt: SO_ERROR");
    return 0;
  }
  /* This checks the status of the original connect call. */
  if (status == 0)
    SET_NEXT_STATE (STATE_MAGIC_START);
  else
    SET_NEXT_STATE (STATE_CONNECT_TCP_NEXT_ADDRESS);
  return 0;

}

static int
enter_STATE_CONNECT_TCP_CONNECTING (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_TCP_CONNECTING;

  r = _enter_STATE_CONNECT_TCP_CONNECTING (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT_TCP.CONNECTING",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT_TCP.NEXT_ADDRESS: Connecting to the next address over a TCP socket */
static int
_enter_STATE_CONNECT_TCP_NEXT_ADDRESS (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 210 "generator/states-connect.c"

  if (h->sock) {
    h->sock->ops->close (h->sock);
    h->sock = NULL;
  }
  if (h->rp)
    h->rp = h->rp->ai_next;
  SET_NEXT_STATE (STATE_CONNECT_TCP_CONNECT);
  return 0;

}

static int
enter_STATE_CONNECT_TCP_NEXT_ADDRESS (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_TCP_NEXT_ADDRESS;

  r = _enter_STATE_CONNECT_TCP_NEXT_ADDRESS (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT_TCP.NEXT_ADDRESS",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CONNECT_COMMAND.START: Connect to a subprocess */
static int
_enter_STATE_CONNECT_COMMAND_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 220 "generator/states-connect.c"

  int sv[2];
  pid_t pid;
  int flags;

  assert (!h->sock);
  assert (h->argv);
  assert (h->argv[0]);
  if (socketpair (AF_UNIX, SOCK_STREAM|SOCK_CLOEXEC, 0, sv) == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (errno, "socketpair");
    return 0;
  }

  pid = fork ();
  if (pid == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (errno, "fork");
    close (sv[0]);
    close (sv[1]);
    return 0;
  }
  if (pid == 0) {         /* child - run command */
    close (0);
    close (1);
    close (sv[0]);
    dup2 (sv[1], 0);
    dup2 (sv[1], 1);
    close (sv[1]);

    /* Restore SIGPIPE back to SIG_DFL. */
    signal (SIGPIPE, SIG_DFL);

    execvp (h->argv[0], h->argv);
    perror (h->argv[0]);
    _exit (EXIT_FAILURE);
  }

  /* Parent. */
  close (sv[1]);

  h->pid = pid;

  /* The socket must be set to non-blocking only in the parent,
   * because the child may not be expecting a non-blocking socket.
   */
  flags = fcntl (sv[0], F_GETFL, 0);
  if (flags == -1 ||
      fcntl (sv[0], F_SETFL, flags|O_NONBLOCK) == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    close (sv[0]);
    return 0;
  }

  h->sock = nbd_internal_socket_create (sv[0]);
  if (!h->sock) {
    SET_NEXT_STATE (STATE_DEAD);
    close (sv[0]);
    return 0;
  }

  /* The sockets are connected already, we can jump directly to
   * receiving the server magic.
   */
  SET_NEXT_STATE (STATE_MAGIC_START);
  return 0;

}

static int
enter_STATE_CONNECT_COMMAND_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CONNECT_COMMAND_START;

  r = _enter_STATE_CONNECT_COMMAND_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CONNECT_COMMAND.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* MAGIC.START: Prepare to receive the magic identification from remote */
static int
_enter_STATE_MAGIC_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-magic.c"

  h->rbuf = &h->sbuf;
  h->rlen = 16;
  SET_NEXT_STATE (STATE_MAGIC_RECV_MAGIC);
  return 0;

}

static int
enter_STATE_MAGIC_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_MAGIC_START;

  r = _enter_STATE_MAGIC_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "MAGIC.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* MAGIC.RECV_MAGIC: Receive initial magic identification from remote */
static int
_enter_STATE_MAGIC_RECV_MAGIC (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 28 "generator/states-magic.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_MAGIC_CHECK_MAGIC);
  }
  return 0;

}

static int
enter_STATE_MAGIC_RECV_MAGIC (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_MAGIC_RECV_MAGIC;

  r = _enter_STATE_MAGIC_RECV_MAGIC (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "MAGIC.RECV_MAGIC",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* MAGIC.CHECK_MAGIC: Check magic and version sent by remote */
static int
_enter_STATE_MAGIC_CHECK_MAGIC (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 35 "generator/states-magic.c"

  uint64_t version;

  if (strncmp (h->sbuf.new_handshake.nbdmagic, "NBDMAGIC", 8) != 0) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (0, "handshake: server did not send expected NBD magic");
    return 0;
  }

  version = be64toh (h->sbuf.new_handshake.version);
  if (version == NBD_NEW_VERSION)
    SET_NEXT_STATE (STATE_NEWSTYLE_START);
  else if (version == NBD_OLD_VERSION)
    SET_NEXT_STATE (STATE_OLDSTYLE_START);
  else {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (0, "handshake: server is not either an oldstyle or fixed newstyle NBD server");
    return 0;
  }
  return 0;

}

static int
enter_STATE_MAGIC_CHECK_MAGIC (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_MAGIC_CHECK_MAGIC;

  r = _enter_STATE_MAGIC_CHECK_MAGIC (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "MAGIC.CHECK_MAGIC",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* OLDSTYLE.START: Prepare to receive remainder of oldstyle header */
static int
_enter_STATE_OLDSTYLE_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-oldstyle.c"

  /* We've already read the first 16 bytes of the handshake, we must
   * now read the remainder.
   */
  h->rbuf = &h->sbuf.old_handshake;
  h->rlen = sizeof h->sbuf.old_handshake;
  h->rbuf += 16;
  h->rlen -= 16;
  SET_NEXT_STATE (STATE_OLDSTYLE_RECV_REMAINING);
  return 0;

}

static int
enter_STATE_OLDSTYLE_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_OLDSTYLE_START;

  r = _enter_STATE_OLDSTYLE_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "OLDSTYLE.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* OLDSTYLE.RECV_REMAINING: Receive remainder of oldstyle header */
static int
_enter_STATE_OLDSTYLE_RECV_REMAINING (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 33 "generator/states-oldstyle.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_OLDSTYLE_CHECK);
  }
  return 0;

}

static int
enter_STATE_OLDSTYLE_RECV_REMAINING (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_OLDSTYLE_RECV_REMAINING;

  r = _enter_STATE_OLDSTYLE_RECV_REMAINING (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "OLDSTYLE.RECV_REMAINING",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* OLDSTYLE.CHECK: Check oldstyle header */
static int
_enter_STATE_OLDSTYLE_CHECK (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 40 "generator/states-oldstyle.c"

  uint64_t exportsize;
  uint16_t gflags, eflags;

  /* We already checked the magic and version in MAGIC.CHECK_MAGIC. */
  exportsize = be64toh (h->sbuf.old_handshake.exportsize);
  gflags = be16toh (h->sbuf.old_handshake.gflags);
  eflags = be16toh (h->sbuf.old_handshake.eflags);

  /* Server is unable to upgrade to TLS.  If h->tls is not 'require' (2)
   * then we can continue unencrypted.
   */
  if (h->tls == LIBNBD_TLS_REQUIRE) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (ENOTSUP, "handshake: server is oldstyle, "
               "but handle TLS setting is 'require' (2)");
    return 0;
  }

  h->gflags = gflags;
  debug (h, "gflags: 0x%" PRIx16, gflags);

  if (nbd_internal_set_size_and_flags (h, exportsize, eflags) == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }

  SET_NEXT_STATE (STATE_READY);

  return 0;

}

static int
enter_STATE_OLDSTYLE_CHECK (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_OLDSTYLE_CHECK;

  r = _enter_STATE_OLDSTYLE_CHECK (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "OLDSTYLE.CHECK",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.START: Prepare to receive newstyle gflags from remote */
static int
_enter_STATE_NEWSTYLE_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 114 "generator/states-newstyle.c"

  h->rbuf = &h->gflags;
  h->rlen = 2;
  SET_NEXT_STATE (STATE_NEWSTYLE_RECV_GFLAGS);
  return 0;

}

static int
enter_STATE_NEWSTYLE_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_START;

  r = _enter_STATE_NEWSTYLE_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.RECV_GFLAGS: Receive newstyle gflags from remote */
static int
_enter_STATE_NEWSTYLE_RECV_GFLAGS (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 120 "generator/states-newstyle.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_NEWSTYLE_CHECK_GFLAGS);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_RECV_GFLAGS (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_RECV_GFLAGS;

  r = _enter_STATE_NEWSTYLE_RECV_GFLAGS (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.RECV_GFLAGS",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.CHECK_GFLAGS: Check global flags sent by remote */
static int
_enter_STATE_NEWSTYLE_CHECK_GFLAGS (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 127 "generator/states-newstyle.c"

  uint32_t cflags;

  h->gflags = be16toh (h->gflags);
  if ((h->gflags & NBD_FLAG_FIXED_NEWSTYLE) == 0 &&
      h->tls == LIBNBD_TLS_REQUIRE) {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (ENOTSUP, "handshake: server is not fixed newstyle, "
               "but handle TLS setting is 'require' (2)");
    return 0;
  }

  cflags = h->gflags & (NBD_FLAG_FIXED_NEWSTYLE|NBD_FLAG_NO_ZEROES);
  h->sbuf.cflags = htobe32 (cflags);
  h->wbuf = &h->sbuf;
  h->wlen = 4;
  SET_NEXT_STATE (STATE_NEWSTYLE_SEND_CFLAGS);
  return 0;

}

static int
enter_STATE_NEWSTYLE_CHECK_GFLAGS (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_CHECK_GFLAGS;

  r = _enter_STATE_NEWSTYLE_CHECK_GFLAGS (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.CHECK_GFLAGS",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.SEND_CFLAGS: Send newstyle client flags to remote */
static int
_enter_STATE_NEWSTYLE_SEND_CFLAGS (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 146 "generator/states-newstyle.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    /* Start sending options. */
    if ((h->gflags & NBD_FLAG_FIXED_NEWSTYLE) == 0)
      SET_NEXT_STATE (STATE_NEWSTYLE_OPT_EXPORT_NAME_START);
    else
      SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_START);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_SEND_CFLAGS (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_SEND_CFLAGS;

  r = _enter_STATE_NEWSTYLE_SEND_CFLAGS (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.SEND_CFLAGS",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.START: Try to send newstyle NBD_OPT_STARTTLS to upgrade to TLS */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-newstyle-opt-starttls.c"

  /* If TLS was not requested we skip this option and go to the next one. */
  if (h->tls == LIBNBD_TLS_DISABLE) {
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START);
    return 0;
  }

  h->sbuf.option.version = htobe64 (NBD_NEW_VERSION);
  h->sbuf.option.option = htobe32 (NBD_OPT_STARTTLS);
  h->sbuf.option.optlen = 0;
  h->wbuf = &h->sbuf;
  h->wlen = sizeof (h->sbuf.option);
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_SEND);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_START;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.SEND: Send newstyle NBD_OPT_STARTTLS to upgrade to TLS */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_SEND (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 37 "generator/states-newstyle-opt-starttls.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->rbuf = &h->sbuf;
    h->rlen = sizeof (h->sbuf.or.option_reply);
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_SEND (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_SEND;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_SEND (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.SEND",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.RECV_REPLY: Receive newstyle NBD_OPT_STARTTLS reply */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 47 "generator/states-newstyle-opt-starttls.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    if (prepare_for_reply_payload (h, NBD_OPT_STARTTLS) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.RECV_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.RECV_REPLY_PAYLOAD: Receive any newstyle NBD_OPT_STARTTLS reply payload */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 59 "generator/states-newstyle-opt-starttls.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.RECV_REPLY_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.CHECK_REPLY: Check newstyle NBD_OPT_STARTTLS reply */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 66 "generator/states-newstyle-opt-starttls.c"

  uint32_t reply;
  struct socket *new_sock;

  reply = be32toh (h->sbuf.or.option_reply.reply);
  switch (reply) {
  case NBD_REP_ACK:
    new_sock = nbd_internal_crypto_create_session (h, h->sock);
    if (new_sock == NULL) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }
    h->sock = new_sock;
    if (nbd_internal_crypto_is_reading (h))
      SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ);
    else
      SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE);
    return 0;

  default:
    if (handle_reply_error (h) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }

    /* Server refused to upgrade to TLS.  If h->tls is not 'require' (2)
     * then we can continue unencrypted.
     */
    if (h->tls == LIBNBD_TLS_REQUIRE) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (ENOTSUP, "handshake: server refused TLS, "
                 "but handle TLS setting is 'require' (2)");
      return 0;
    }

    debug (h,
           "server refused TLS (%s), continuing with unencrypted connection",
           reply == NBD_REP_ERR_POLICY ? "policy" : "not supported");
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START);
    return 0;
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.CHECK_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_READ: TLS handshake (reading) */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 109 "generator/states-newstyle-opt-starttls.c"

  int r;

  r = nbd_internal_crypto_handshake (h);
  if (r == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }
  if (r == 0) {
    /* Finished handshake. */
    nbd_internal_crypto_debug_tls_enabled (h);

    /* Continue with option negotiation. */
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START);
    return 0;
  }
  /* Continue handshake. */
  if (nbd_internal_crypto_is_reading (h))
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ);
  else
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_READ",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_WRITE: TLS handshake (writing) */
static int
_enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 132 "generator/states-newstyle-opt-starttls.c"

  int r;

  r = nbd_internal_crypto_handshake (h);
  if (r == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }
  if (r == 0) {
    /* Finished handshake. */
    debug (h, "connection is using TLS");

    /* Continue with option negotiation. */
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START);
    return 0;
  }
  /* Continue handshake. */
  if (nbd_internal_crypto_is_reading (h))
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ);
  else
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE;

  r = _enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_WRITE",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STRUCTURED_REPLY.START: Try to negotiate newstyle NBD_OPT_STRUCTURED_REPLY */
static int
_enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-newstyle-opt-structured-reply.c"

  h->sbuf.option.version = htobe64 (NBD_NEW_VERSION);
  h->sbuf.option.option = htobe32 (NBD_OPT_STRUCTURED_REPLY);
  h->sbuf.option.optlen = htobe32 (0);
  h->wbuf = &h->sbuf;
  h->wlen = sizeof h->sbuf.option;
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START;

  r = _enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STRUCTURED_REPLY.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STRUCTURED_REPLY.SEND: Send newstyle NBD_OPT_STRUCTURED_REPLY negotiation request */
static int
_enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 31 "generator/states-newstyle-opt-structured-reply.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->rbuf = &h->sbuf;
    h->rlen = sizeof h->sbuf.or.option_reply;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND;

  r = _enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STRUCTURED_REPLY.SEND",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY: Receive newstyle NBD_OPT_STRUCTURED_REPLY option reply */
static int
_enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 41 "generator/states-newstyle-opt-structured-reply.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    if (prepare_for_reply_payload (h, NBD_OPT_STRUCTURED_REPLY) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY_PAYLOAD: Receive any newstyle NBD_OPT_STRUCTURED_REPLY reply payload */
static int
_enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 53 "generator/states-newstyle-opt-structured-reply.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD;

  r = _enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_STRUCTURED_REPLY.CHECK_REPLY: Check newstyle NBD_OPT_STRUCTURED_REPLY option reply */
static int
_enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 60 "generator/states-newstyle-opt-structured-reply.c"

  uint32_t reply;

  reply = be32toh (h->sbuf.or.option_reply.reply);
  switch (reply) {
  case NBD_REP_ACK:
    debug (h, "negotiated structured replies on this connection");
    h->structured_replies = true;
    break;
  default:
    if (handle_reply_error (h) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }

    debug (h, "structured replies are not supported by this server");
    h->structured_replies = false;
    break;
  }

  /* Next option. */
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_STRUCTURED_REPLY.CHECK_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.START: Try to negotiate newstyle NBD_OPT_SET_META_CONTEXT */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-newstyle-opt-set-meta-context.c"

  size_t i, nr_queries;
  uint32_t len;

  /* If the server doesn't support SRs then we must skip this group.
   * Also we skip the group if the client didn't request any metadata
   * contexts.
   */
  if (!h->structured_replies ||
      h->request_meta_contexts == NULL ||
      nbd_internal_string_list_length (h->request_meta_contexts) == 0) {
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_START);
    return 0;
  }

  assert (h->meta_contexts == NULL);

  /* Calculate the length of the option request data. */
  len = 4 /* exportname len */ + strlen (h->export_name) + 4 /* nr queries */;
  nr_queries = nbd_internal_string_list_length (h->request_meta_contexts);
  for (i = 0; i < nr_queries; ++i)
    len += 4 /* length of query */ + strlen (h->request_meta_contexts[i]);

  h->sbuf.option.version = htobe64 (NBD_NEW_VERSION);
  h->sbuf.option.option = htobe32 (NBD_OPT_SET_META_CONTEXT);
  h->sbuf.option.optlen = htobe32 (len);
  h->wbuf = &h->sbuf;
  h->wlen = sizeof (h->sbuf.option);
  h->wflags = MSG_MORE;
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.SEND: Send newstyle NBD_OPT_SET_META_CONTEXT */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 54 "generator/states-newstyle-opt-set-meta-context.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->sbuf.len = htobe32 (strlen (h->export_name));
    h->wbuf = &h->sbuf.len;
    h->wlen = sizeof h->sbuf.len;
    h->wflags = MSG_MORE;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.SEND",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAMELEN: Send newstyle NBD_OPT_SET_META_CONTEXT export name length */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 66 "generator/states-newstyle-opt-set-meta-context.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->wbuf = h->export_name;
    h->wlen = strlen (h->export_name);
    h->wflags = MSG_MORE;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAMELEN",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAME: Send newstyle NBD_OPT_SET_META_CONTEXT export name */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 77 "generator/states-newstyle-opt-set-meta-context.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->sbuf.nrqueries =
      htobe32 (nbd_internal_string_list_length (h->request_meta_contexts));
    h->wbuf = &h->sbuf;
    h->wlen = sizeof h->sbuf.nrqueries;
    h->wflags = MSG_MORE;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAME",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.SEND_NRQUERIES: Send newstyle NBD_OPT_SET_META_CONTEXT number of queries */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 90 "generator/states-newstyle-opt-set-meta-context.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->querynum = 0;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_NRQUERIES",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_NEXT_QUERY: Prepare to send newstyle NBD_OPT_SET_META_CONTEXT query */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 99 "generator/states-newstyle-opt-set-meta-context.c"

  const char *query = h->request_meta_contexts[h->querynum];

  if (query == NULL) { /* end of list of requested meta contexts */
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY);
    return 0;
  }

  h->sbuf.len = htobe32 (strlen (query));
  h->wbuf = &h->sbuf.len;
  h->wlen = sizeof h->sbuf.len;
  h->wflags = MSG_MORE;
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_NEXT_QUERY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERYLEN: Send newstyle NBD_OPT_SET_META_CONTEXT query length */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 114 "generator/states-newstyle-opt-set-meta-context.c"

  const char *query = h->request_meta_contexts[h->querynum];

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->wbuf = query;
    h->wlen = strlen (query);
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERYLEN",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERY: Send newstyle NBD_OPT_SET_META_CONTEXT query */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 126 "generator/states-newstyle-opt-set-meta-context.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->querynum++;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_FOR_REPLY: Prepare to receive newstyle NBD_OPT_SET_META_CONTEXT option reply */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 135 "generator/states-newstyle-opt-set-meta-context.c"

  h->rbuf = &h->sbuf.or.option_reply;
  h->rlen = sizeof h->sbuf.or.option_reply;
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_FOR_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY: Receive newstyle NBD_OPT_SET_META_CONTEXT option reply */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 141 "generator/states-newstyle-opt-set-meta-context.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    if (prepare_for_reply_payload (h, NBD_OPT_SET_META_CONTEXT) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY_PAYLOAD: Receive newstyle NBD_OPT_SET_META_CONTEXT option reply payload */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 153 "generator/states-newstyle-opt-set-meta-context.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_SET_META_CONTEXT.CHECK_REPLY: Check newstyle NBD_OPT_SET_META_CONTEXT option reply */
static int
_enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 160 "generator/states-newstyle-opt-set-meta-context.c"

  uint32_t reply;
  uint32_t len;
  const size_t maxpayload = sizeof h->sbuf.or.payload.context;
  struct meta_context *meta_context;

  reply = be32toh (h->sbuf.or.option_reply.reply);
  len = be32toh (h->sbuf.or.option_reply.replylen);
  switch (reply) {
  case NBD_REP_ACK:           /* End of list of replies. */
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_START);
    break;
  case NBD_REP_META_CONTEXT:  /* A context. */
    if (len > maxpayload)
      debug (h, "skipping too large meta context");
    else {
      assert (len > sizeof h->sbuf.or.payload.context.context.context_id);
      meta_context = malloc (sizeof *meta_context);
      if (meta_context == NULL) {
        set_error (errno, "malloc");
        SET_NEXT_STATE (STATE_DEAD);
        return 0;
      }
      meta_context->context_id =
        be32toh (h->sbuf.or.payload.context.context.context_id);
      /* String payload is not NUL-terminated. */
      meta_context->name = strndup (h->sbuf.or.payload.context.str,
                                    len - sizeof meta_context->context_id);
      if (meta_context->name == NULL) {
        set_error (errno, "strdup");
        SET_NEXT_STATE (STATE_DEAD);
        free (meta_context);
        return 0;
      }
      debug (h, "negotiated %s with context ID %" PRIu32,
             meta_context->name, meta_context->context_id);
      meta_context->next = h->meta_contexts;
      h->meta_contexts = meta_context;
    }
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY);
    break;
  default:
    /* Anything else is an error, ignore it */
    if (handle_reply_error (h) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }

    debug (h, "handshake: unexpected error from "
           "NBD_OPT_SET_META_CONTEXT (%" PRIu32 ")", reply);
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_START);
    break;
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_SET_META_CONTEXT.CHECK_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.START: Try to send newstyle NBD_OPT_GO to end handshake */
static int
_enter_STATE_NEWSTYLE_OPT_GO_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-newstyle-opt-go.c"

  h->sbuf.option.version = htobe64 (NBD_NEW_VERSION);
  h->sbuf.option.option = htobe32 (NBD_OPT_GO);
  h->sbuf.option.optlen =
    htobe32 (/* exportnamelen */ 4 + strlen (h->export_name) + /* nrinfos */ 2);
  h->wbuf = &h->sbuf;
  h->wlen = sizeof h->sbuf.option;
  h->wflags = MSG_MORE;
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_SEND);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_START;

  r = _enter_STATE_NEWSTYLE_OPT_GO_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.SEND: Send newstyle NBD_OPT_GO to end handshake */
static int
_enter_STATE_NEWSTYLE_OPT_GO_SEND (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 33 "generator/states-newstyle-opt-go.c"

  const uint32_t exportnamelen = strlen (h->export_name);

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->sbuf.len = htobe32 (exportnamelen);
    h->wbuf = &h->sbuf;
    h->wlen = 4;
    h->wflags = MSG_MORE;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_SEND (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_SEND;

  r = _enter_STATE_NEWSTYLE_OPT_GO_SEND (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.SEND",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.SEND_EXPORTNAMELEN: Send newstyle NBD_OPT_GO export name length */
static int
_enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 47 "generator/states-newstyle-opt-go.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->wbuf = h->export_name;
    h->wlen = strlen (h->export_name);
    h->wflags = MSG_MORE;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_SEND_EXPORT);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN;

  r = _enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.SEND_EXPORTNAMELEN",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.SEND_EXPORT: Send newstyle NBD_OPT_GO export name */
static int
_enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORT (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 58 "generator/states-newstyle-opt-go.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->sbuf.nrinfos = 0;
    h->wbuf = &h->sbuf;
    h->wlen = 2;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORT (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_SEND_EXPORT;

  r = _enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORT (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.SEND_EXPORT",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.SEND_NRINFOS: Send newstyle NBD_OPT_GO number of infos */
static int
_enter_STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 69 "generator/states-newstyle-opt-go.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->rbuf = &h->sbuf;
    h->rlen = sizeof h->sbuf.or.option_reply;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_RECV_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS;

  r = _enter_STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.SEND_NRINFOS",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.RECV_REPLY: Receive newstyle NBD_OPT_GO reply */
static int
_enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 79 "generator/states-newstyle-opt-go.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    if (prepare_for_reply_payload (h, NBD_OPT_GO) == -1) {
      SET_NEXT_STATE (STATE_DEAD);
      return 0;
    }
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_RECV_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.RECV_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.RECV_REPLY_PAYLOAD: Receive newstyle NBD_OPT_GO reply payload */
static int
_enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 91 "generator/states-newstyle-opt-go.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_CHECK_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD;

  r = _enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.RECV_REPLY_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_GO.CHECK_REPLY: Check newstyle NBD_OPT_GO reply */
static int
_enter_STATE_NEWSTYLE_OPT_GO_CHECK_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 98 "generator/states-newstyle-opt-go.c"

  uint32_t reply;
  uint32_t len;
  const size_t maxpayload = sizeof h->sbuf.or.payload;
  uint16_t info;
  uint64_t exportsize;
  uint16_t eflags;

  reply = be32toh (h->sbuf.or.option_reply.reply);
  len = be32toh (h->sbuf.or.option_reply.replylen);

  switch (reply) {
  case NBD_REP_ACK:
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case NBD_REP_INFO:
    if (len > maxpayload /* see RECV_NEWSTYLE_OPT_GO_REPLY */)
      debug (h, "skipping large NBD_REP_INFO");
    else {
      assert (len >= sizeof h->sbuf.or.payload.export.info);
      info = be16toh (h->sbuf.or.payload.export.info);
      switch (info) {
      case NBD_INFO_EXPORT:
        if (len != sizeof h->sbuf.or.payload.export) {
          SET_NEXT_STATE (STATE_DEAD);
          set_error (0, "handshake: incorrect NBD_INFO_EXPORT option reply length");
          return 0;
        }
        exportsize = be64toh (h->sbuf.or.payload.export.exportsize);
        eflags = be16toh (h->sbuf.or.payload.export.eflags);
        if (nbd_internal_set_size_and_flags (h, exportsize, eflags) == -1) {
          SET_NEXT_STATE (STATE_DEAD);
          return 0;
        }
        break;
      default:
        /* XXX Handle other info types, like NBD_INFO_BLOCK_SIZE */
        debug (h, "skipping unknown NBD_REP_INFO type %d",
               be16toh (h->sbuf.or.payload.export.info));
        break;
      }
    }
    /* Server is allowed to send any number of NBD_REP_INFO, read next one. */
    h->rbuf = &h->sbuf;
    h->rlen = sizeof (h->sbuf.or.option_reply);
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_GO_RECV_REPLY);
    return 0;
  case NBD_REP_ERR_UNSUP:
    debug (h, "server is confused by NBD_OPT_GO, continuing anyway");
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_EXPORT_NAME_START);
    return 0;
  default:
    if (handle_reply_error (h) == 0) {
      /* Decode expected known errors into a nicer string */
      switch (reply) {
      case NBD_REP_ERR_POLICY:
      case NBD_REP_ERR_PLATFORM:
        set_error (0, "handshake: server policy prevents NBD_OPT_GO");
        break;
      case NBD_REP_ERR_INVALID:
      case NBD_REP_ERR_TOO_BIG:
        set_error (EINVAL, "handshake: server rejected NBD_OPT_GO as invalid");
        break;
      case NBD_REP_ERR_TLS_REQD:
        set_error (ENOTSUP, "handshake: server requires TLS encryption first");
        break;
      case NBD_REP_ERR_UNKNOWN:
        set_error (ENOENT, "handshake: server has no export named '%s'",
                   h->export_name);
        break;
      case NBD_REP_ERR_SHUTDOWN:
        set_error (ESHUTDOWN, "handshake: server is shutting down");
        break;
      case NBD_REP_ERR_BLOCK_SIZE_REQD:
        set_error (EINVAL, "handshake: server requires specific block sizes");
        break;
      default:
        set_error (0, "handshake: unknown reply from NBD_OPT_GO: 0x%" PRIx32,
                   reply);
      }
    }
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }

}

static int
enter_STATE_NEWSTYLE_OPT_GO_CHECK_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_GO_CHECK_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_GO_CHECK_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_GO.CHECK_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_EXPORT_NAME.START: Try to send newstyle NBD_OPT_EXPORT_NAME to end handshake */
static int
_enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-newstyle-opt-export-name.c"

  h->sbuf.option.version = htobe64 (NBD_NEW_VERSION);
  h->sbuf.option.option = htobe32 (NBD_OPT_EXPORT_NAME);
  h->sbuf.option.optlen = strlen (h->export_name);
  h->wbuf = &h->sbuf;
  h->wlen = sizeof h->sbuf.option;
  h->wflags = MSG_MORE;
  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_EXPORT_NAME_START;

  r = _enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_EXPORT_NAME.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_EXPORT_NAME.SEND: Send newstyle NBD_OPT_EXPORT_NAME to end handshake */
static int
_enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 32 "generator/states-newstyle-opt-export-name.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->wbuf = h->export_name;
    h->wlen = strlen (h->export_name);
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND;

  r = _enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_EXPORT_NAME.SEND",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_EXPORT_NAME.SEND_EXPORT: Send newstyle NBD_OPT_EXPORT_NAME export name */
static int
_enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 42 "generator/states-newstyle-opt-export-name.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:
    h->rbuf = &h->sbuf;
    h->rlen = sizeof h->sbuf.export_name_reply;
    if ((h->gflags & NBD_FLAG_NO_ZEROES) != 0)
      h->rlen -= sizeof h->sbuf.export_name_reply.zeroes;
    SET_NEXT_STATE (STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT;

  r = _enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_EXPORT_NAME.SEND_EXPORT",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_EXPORT_NAME.RECV_REPLY: Receive newstyle NBD_OPT_EXPORT_NAME reply */
static int
_enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 54 "generator/states-newstyle-opt-export-name.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY);
  }
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_EXPORT_NAME.RECV_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* NEWSTYLE.OPT_EXPORT_NAME.CHECK_REPLY: Check newstyle NBD_OPT_EXPORT_NAME reply */
static int
_enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 61 "generator/states-newstyle-opt-export-name.c"

  uint64_t exportsize;
  uint16_t eflags;

  exportsize = be64toh (h->sbuf.export_name_reply.exportsize);
  eflags = be16toh (h->sbuf.export_name_reply.eflags);
  if (nbd_internal_set_size_and_flags (h, exportsize, eflags) == -1) {
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }
  SET_NEXT_STATE (STATE_READY);
  return 0;

}

static int
enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY;

  r = _enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "NEWSTYLE.OPT_EXPORT_NAME.CHECK_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* READY: Connection is ready to process NBD commands */
static int
_enter_STATE_READY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 160 "generator/states.c"

  if (h->cmds_to_issue)
    SET_NEXT_STATE (STATE_ISSUE_COMMAND_START);
  else {
    assert (h->sock);
    if (h->sock->ops->pending && h->sock->ops->pending (h->sock))
      SET_NEXT_STATE (STATE_REPLY_START);
  }
  return 0;

}

static int
enter_STATE_READY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_READY;

  r = _enter_STATE_READY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "READY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.START: Begin issuing a command to the remote server */
static int
_enter_STATE_ISSUE_COMMAND_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-issue-command.c"

  struct command *cmd;

  assert (h->cmds_to_issue != NULL);
  cmd = h->cmds_to_issue;

  /* Were we interrupted by reading a reply to an earlier command? If
   * so, we can only get back here after a non-blocking jaunt through
   * the REPLY engine, which means we are unlikely to be unblocked for
   * writes yet; we want to advance back to the correct state but
   * without trying a send_from_wbuf that will likely return 1.
   */
  if (h->wlen) {
    if (h->in_write_payload)
      SET_NEXT_STATE_AND_BLOCK (STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD);
    else
      SET_NEXT_STATE_AND_BLOCK (STATE_ISSUE_COMMAND_SEND_REQUEST);
    return 0;
  }

  h->request.magic = htobe32 (NBD_REQUEST_MAGIC);
  h->request.flags = htobe16 (cmd->flags);
  h->request.type = htobe16 (cmd->type);
  h->request.handle = htobe64 (cmd->cookie);
  h->request.offset = htobe64 (cmd->offset);
  h->request.count = htobe32 ((uint32_t) cmd->count);
  h->wbuf = &h->request;
  h->wlen = sizeof (h->request);
  if (cmd->type == NBD_CMD_WRITE || cmd->next)
    h->wflags = MSG_MORE;
  SET_NEXT_STATE (STATE_ISSUE_COMMAND_SEND_REQUEST);
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_START;

  r = _enter_STATE_ISSUE_COMMAND_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.SEND_REQUEST: Sending a request to the remote server */
static int
_enter_STATE_ISSUE_COMMAND_SEND_REQUEST (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 55 "generator/states-issue-command.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD);
  }
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_SEND_REQUEST (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_SEND_REQUEST;

  r = _enter_STATE_ISSUE_COMMAND_SEND_REQUEST (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.SEND_REQUEST",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.PAUSE_SEND_REQUEST: Interrupt send request to receive an earlier command's reply */
static int
_enter_STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 62 "generator/states-issue-command.c"

  assert (h->wlen);
  assert (h->cmds_to_issue != NULL);
  h->in_write_payload = false;
  SET_NEXT_STATE (STATE_REPLY_START);
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST;

  r = _enter_STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.PAUSE_SEND_REQUEST",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.PREPARE_WRITE_PAYLOAD: Prepare the write payload to send to the remote server */
static int
_enter_STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 69 "generator/states-issue-command.c"

  struct command *cmd;

  assert (h->cmds_to_issue != NULL);
  cmd = h->cmds_to_issue;
  assert (cmd->cookie == be64toh (h->request.handle));
  if (cmd->type == NBD_CMD_WRITE) {
    h->wbuf = cmd->data;
    h->wlen = cmd->count;
    if (cmd->next && cmd->count < 64 * 1024)
      h->wflags = MSG_MORE;
    SET_NEXT_STATE (STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD);
  }
  else
    SET_NEXT_STATE (STATE_ISSUE_COMMAND_FINISH);
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD;

  r = _enter_STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.PREPARE_WRITE_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.SEND_WRITE_PAYLOAD: Sending the write payload to the remote server */
static int
_enter_STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 86 "generator/states-issue-command.c"

  switch (send_from_wbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 0:  SET_NEXT_STATE (STATE_ISSUE_COMMAND_FINISH);
  }
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD;

  r = _enter_STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.SEND_WRITE_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.PAUSE_WRITE_PAYLOAD: Interrupt write payload to receive an earlier command's reply */
static int
_enter_STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 93 "generator/states-issue-command.c"

  assert (h->wlen);
  assert (h->cmds_to_issue != NULL);
  h->in_write_payload = true;
  SET_NEXT_STATE (STATE_REPLY_START);
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD;

  r = _enter_STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.PAUSE_WRITE_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* ISSUE_COMMAND.FINISH: Finish issuing a command */
static int
_enter_STATE_ISSUE_COMMAND_FINISH (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 100 "generator/states-issue-command.c"

  struct command *cmd;

  assert (!h->wlen);
  assert (h->cmds_to_issue != NULL);
  cmd = h->cmds_to_issue;
  assert (cmd->cookie == be64toh (h->request.handle));
  h->cmds_to_issue = cmd->next;
  if (h->cmds_to_issue_tail == cmd)
    h->cmds_to_issue_tail = NULL;
  cmd->next = h->cmds_in_flight;
  h->cmds_in_flight = cmd;
  SET_NEXT_STATE (STATE_READY);
  return 0;

}

static int
enter_STATE_ISSUE_COMMAND_FINISH (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_ISSUE_COMMAND_FINISH;

  r = _enter_STATE_ISSUE_COMMAND_FINISH (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "ISSUE_COMMAND.FINISH",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.START: Prepare to receive a reply from the remote server */
static int
_enter_STATE_REPLY_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 44 "generator/states-reply.c"

  /* If rlen is non-zero, we are resuming an earlier reply cycle. */
  if (h->rlen > 0) {
    if (h->reply_cmd) {
      assert (nbd_internal_is_state_processing (h->reply_cmd->state));
      SET_NEXT_STATE (h->reply_cmd->state);
    }
    else
      SET_NEXT_STATE (STATE_REPLY_RECV_REPLY);
    return 0;
  }

  /* This state is entered when a read notification is received in the
   * READY state.  Therefore we know the socket is readable here.
   * Reading a zero length now would indicate that the socket has been
   * closed by the server and so we should jump to the CLOSED state.
   * However recv_into_rbuf will fail in this case, so test it as a
   * special case.
   */
  ssize_t r;

  /* We read all replies initially as if they are simple replies, but
   * check the magic in CHECK_SIMPLE_OR_STRUCTURED_REPLY below.
   * This works because the structured_reply header is larger.
   */
  assert (h->reply_cmd == NULL);
  assert (h->rlen == 0);

  h->rbuf = &h->sbuf;
  h->rlen = sizeof h->sbuf.simple_reply;

  r = h->sock->ops->recv (h, h->sock, h->rbuf, h->rlen);
  if (r == -1) {
    /* This should never happen because when we enter this state we
     * should have notification that the socket is ready to read.
     * However if for some reason it does happen, ignore it - we will
     * reenter this same state again next time the socket is ready to
     * read.
     */
    if (errno == EAGAIN || errno == EWOULDBLOCK)
      return 0;

    /* sock->ops->recv called set_error already. */
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }
  if (r == 0) {
    SET_NEXT_STATE (STATE_CLOSED);
    return 0;
  }

  h->rbuf += r;
  h->rlen -= r;
  SET_NEXT_STATE (STATE_REPLY_RECV_REPLY);
  return 0;

}

static int
enter_STATE_REPLY_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_START;

  r = _enter_STATE_REPLY_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.RECV_REPLY: Receive a reply from the remote server */
static int
_enter_STATE_REPLY_RECV_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 100 "generator/states-reply.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1: SET_NEXT_STATE (STATE_READY); return 0;
  case 0: SET_NEXT_STATE (STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY);
  }
  return 0;

}

static int
enter_STATE_REPLY_RECV_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_RECV_REPLY;

  r = _enter_STATE_REPLY_RECV_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.RECV_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.CHECK_SIMPLE_OR_STRUCTURED_REPLY: Check if the reply is a simple or structured reply */
static int
_enter_STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 108 "generator/states-reply.c"

  struct command *cmd;
  uint32_t magic;
  uint64_t cookie;

  magic = be32toh (h->sbuf.simple_reply.magic);
  if (magic == NBD_SIMPLE_REPLY_MAGIC) {
    SET_NEXT_STATE (STATE_REPLY_SIMPLE_REPLY_START);
  }
  else if (magic == NBD_STRUCTURED_REPLY_MAGIC) {
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_START);
  }
  else {
    SET_NEXT_STATE (STATE_DEAD); /* We've probably lost synchronization. */
    set_error (0, "invalid reply magic");
    return 0;
  }

  /* NB: This works for both simple and structured replies because the
   * handle (our cookie) is stored at the same offset.
   */
  cookie = be64toh (h->sbuf.simple_reply.handle);
  /* Find the command amongst the commands in flight. */
  for (cmd = h->cmds_in_flight; cmd != NULL; cmd = cmd->next) {
    if (cmd->cookie == cookie)
      break;
  }
  if (cmd == NULL) {
    /* An unexpected structured reply could be skipped, since it
     * includes a length; similarly an unexpected simple reply can be
     * skipped if we assume it was not a read. However, it's more
     * likely we've lost synchronization with the server.
     */
    SET_NEXT_STATE (STATE_DEAD);
    set_error (0, "no matching cookie found for server reply, "
               "this is probably a bug in the server");
    return 0;
  }
  h->reply_cmd = cmd;
  return 0;

}

static int
enter_STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY;

  r = _enter_STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.CHECK_SIMPLE_OR_STRUCTURED_REPLY",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.SIMPLE_REPLY.START: Parse a simple reply from the server */
static int
_enter_STATE_REPLY_SIMPLE_REPLY_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 22 "generator/states-reply-simple.c"

  struct command *cmd = h->reply_cmd;
  uint32_t error;
  uint64_t cookie;

  error = be32toh (h->sbuf.simple_reply.error);
  cookie = be64toh (h->sbuf.simple_reply.handle);

  assert (cmd);
  assert (cmd->cookie == cookie);

  if (cmd->type == NBD_CMD_READ && h->structured_replies) {
    set_error (0, "server sent unexpected simple reply for read");
    SET_NEXT_STATE(STATE_DEAD);
    return 0;
  }

  cmd->error = nbd_internal_errno_of_nbd_error (error);
  if (cmd->error == 0 && cmd->type == NBD_CMD_READ) {
    h->rbuf = cmd->data;
    h->rlen = cmd->count;
    cmd->data_seen = true;
    SET_NEXT_STATE (STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD);
  }
  else {
    SET_NEXT_STATE (STATE_REPLY_FINISH_COMMAND);
  }
  return 0;

}

static int
enter_STATE_REPLY_SIMPLE_REPLY_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_SIMPLE_REPLY_START;

  r = _enter_STATE_REPLY_SIMPLE_REPLY_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.SIMPLE_REPLY.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.SIMPLE_REPLY.RECV_READ_PAYLOAD: Receiving the read payload for a simple reply */
static int
_enter_STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 51 "generator/states-reply-simple.c"

  struct command *cmd = h->reply_cmd;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    /* guaranteed by START */
    assert (cmd);
    if (CALLBACK_IS_NOT_NULL (cmd->cb.fn.chunk)) {
      int error = 0;

      assert (cmd->error == 0);
      if (CALL_CALLBACK (cmd->cb.fn.chunk,
                         cmd->data, cmd->count,
                         cmd->offset, LIBNBD_READ_DATA,
                         &error) == -1)
        cmd->error = error ? error : EPROTO;
    }

    SET_NEXT_STATE (STATE_REPLY_FINISH_COMMAND);
  }
  return 0;

}

static int
enter_STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD;

  r = _enter_STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.SIMPLE_REPLY.RECV_READ_PAYLOAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.START: Prepare to receive the remaining part of a structured reply */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_START (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 24 "generator/states-reply-structured.c"

  /* We've only read the simple_reply.  The structured_reply is longer,
   * so read the remaining part.
   */
  if (!h->structured_replies) {
    set_error (0, "server sent unexpected structured reply");
    SET_NEXT_STATE(STATE_DEAD);
    return 0;
  }
  h->rbuf = &h->sbuf;
  h->rbuf += sizeof h->sbuf.simple_reply;
  h->rlen = sizeof h->sbuf.sr.structured_reply;
  h->rlen -= sizeof h->sbuf.simple_reply;
  SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING);
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_START (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_START;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_START (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.START",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_REMAINING: Receiving the remaining part of a structured reply */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 40 "generator/states-reply-structured.c"

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:  SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_CHECK);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_REMAINING",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.CHECK: Parse a structured reply from the server */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_CHECK (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 51 "generator/states-reply-structured.c"

  struct command *cmd = h->reply_cmd;
  uint16_t flags, type;
  uint64_t cookie;
  uint32_t length;

  flags = be16toh (h->sbuf.sr.structured_reply.flags);
  type = be16toh (h->sbuf.sr.structured_reply.type);
  cookie = be64toh (h->sbuf.sr.structured_reply.handle);
  length = be32toh (h->sbuf.sr.structured_reply.length);

  assert (cmd);
  assert (cmd->cookie == cookie);

  /* Reject a server that replies with too much information, but don't
   * reject a single structured reply to NBD_CMD_READ on the largest
   * size we were willing to send. The most likely culprit is a server
   * that replies with block status with way too many extents, but any
   * oversized reply is going to take long enough to resync that it is
   * not worth keeping the connection alive.
   */
  if (length > MAX_REQUEST_SIZE + sizeof h->sbuf.sr.payload.offset_data) {
    set_error (0, "invalid server reply length");
    SET_NEXT_STATE (STATE_DEAD);
    return 0;
  }

  if (NBD_REPLY_TYPE_IS_ERR (type)) {
    if (length < sizeof h->sbuf.sr.payload.error.error) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "too short length in structured reply error");
      return 0;
    }
    h->rbuf = &h->sbuf.sr.payload.error.error;
    h->rlen = sizeof h->sbuf.sr.payload.error.error;
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR);
    return 0;
  }
  else if (type == NBD_REPLY_TYPE_NONE) {
    if (length != 0) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "invalid length in NBD_REPLY_TYPE_NONE");
      return 0;
    }
    if (!(flags & NBD_REPLY_FLAG_DONE)) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "NBD_REPLY_FLAG_DONE must be set in NBD_REPLY_TYPE_NONE");
      return 0;
    }
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_FINISH);
    return 0;
  }
  else if (type == NBD_REPLY_TYPE_OFFSET_DATA) {
    /* The spec states that 0-length requests are unspecified, but
     * 0-length replies are broken. Still, it's easy enough to support
     * them as an extension, so we use < instead of <=.
     */
    if (cmd->type != NBD_CMD_READ) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "invalid command for receiving offset-data chunk, "
                 "cmd->type=%" PRIu16 ", "
                 "this is likely to be a bug in the server",
                 cmd->type);
      return 0;
    }
    if (length < sizeof h->sbuf.sr.payload.offset_data) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "too short length in NBD_REPLY_TYPE_OFFSET_DATA");
      return 0;
    }
    h->rbuf = &h->sbuf.sr.payload.offset_data;
    h->rlen = sizeof h->sbuf.sr.payload.offset_data;
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA);
    return 0;
  }
  else if (type == NBD_REPLY_TYPE_OFFSET_HOLE) {
    if (cmd->type != NBD_CMD_READ) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "invalid command for receiving offset-hole chunk, "
                 "cmd->type=%" PRIu16 ", "
                 "this is likely to be a bug in the server",
                 cmd->type);
      return 0;
    }
    if (length != sizeof h->sbuf.sr.payload.offset_hole) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "invalid length in NBD_REPLY_TYPE_OFFSET_HOLE");
      return 0;
    }
    h->rbuf = &h->sbuf.sr.payload.offset_hole;
    h->rlen = sizeof h->sbuf.sr.payload.offset_hole;
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE);
    return 0;
  }
  else if (type == NBD_REPLY_TYPE_BLOCK_STATUS) {
    if (cmd->type != NBD_CMD_BLOCK_STATUS) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "invalid command for receiving block-status chunk, "
                 "cmd->type=%" PRIu16 ", "
                 "this is likely to be a bug in the server",
                 cmd->type);
      return 0;
    }
    /* XXX We should be able to skip the bad reply in these two cases. */
    if (length < 12 || ((length-4) & 7) != 0) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "invalid length in NBD_REPLY_TYPE_BLOCK_STATUS");
      return 0;
    }
    if (CALLBACK_IS_NULL (cmd->cb.fn.extent)) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "not expecting NBD_REPLY_TYPE_BLOCK_STATUS here");
      return 0;
    }
    /* We read the context ID followed by all the entries into a
     * single array and deal with it at the end.
     */
    free (h->bs_entries);
    h->bs_entries = malloc (length);
    if (h->bs_entries == NULL) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (errno, "malloc");
      return 0;
    }
    h->rbuf = h->bs_entries;
    h->rlen = length;
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES);
    return 0;
  }
  else {
    SET_NEXT_STATE (STATE_DEAD);
    set_error (0, "unknown structured reply type (%" PRIu16 ")", type);
    return 0;
  }

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_CHECK (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_CHECK;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_CHECK (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.CHECK",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_ERROR: Receive a structured reply error header */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 186 "generator/states-reply-structured.c"

  uint32_t length, msglen;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    length = be32toh (h->sbuf.sr.structured_reply.length);
    msglen = be16toh (h->sbuf.sr.payload.error.error.len);
    if (msglen > length - sizeof h->sbuf.sr.payload.error.error ||
        msglen > sizeof h->sbuf.sr.payload.error.msg) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "error message length too large");
      return 0;
    }

    h->rbuf = h->sbuf.sr.payload.error.msg;
    h->rlen = msglen;
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_ERROR",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_ERROR_MESSAGE: Receive a structured reply error message */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 211 "generator/states-reply-structured.c"

  uint32_t length, msglen;
  uint16_t type;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    length = be32toh (h->sbuf.sr.structured_reply.length);
    msglen = be16toh (h->sbuf.sr.payload.error.error.len);
    type = be16toh (h->sbuf.sr.structured_reply.type);

    length -= sizeof h->sbuf.sr.payload.error.error + msglen;

    if (msglen)
      debug (h, "structured error server message: %.*s", (int) msglen,
             h->sbuf.sr.payload.error.msg);

    /* Special case two specific errors; ignore the tail for all others */
    h->rbuf = NULL;
    h->rlen = length;
    switch (type) {
    case NBD_REPLY_TYPE_ERROR:
      if (length != 0) {
        SET_NEXT_STATE (STATE_DEAD);
        set_error (0, "error payload length too large");
        return 0;
      }
      break;
    case NBD_REPLY_TYPE_ERROR_OFFSET:
      if (length != sizeof h->sbuf.sr.payload.error.offset) {
        SET_NEXT_STATE (STATE_DEAD);
        set_error (0, "invalid error payload length");
        return 0;
      }
      h->rbuf = &h->sbuf.sr.payload.error.offset;
      break;
    }
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_ERROR_MESSAGE",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_ERROR_TAIL: Receive a structured reply error tail */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 256 "generator/states-reply-structured.c"

  struct command *cmd = h->reply_cmd;
  uint32_t error;
  uint64_t offset;
  uint16_t type;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    error = be32toh (h->sbuf.sr.payload.error.error.error);
    type = be16toh (h->sbuf.sr.structured_reply.type);

    assert (cmd); /* guaranteed by CHECK */
    error = nbd_internal_errno_of_nbd_error (error);

    /* The spec requires the server to send a non-zero error */
    if (error == NBD_SUCCESS) {
      debug (h, "server forgot to set error; using EINVAL");
      error = NBD_EINVAL;
    }
    error = nbd_internal_errno_of_nbd_error (error);

    /* Sanity check that any error offset is in range, then invoke
     * user callback if present.
     */
    if (type == NBD_REPLY_TYPE_ERROR_OFFSET) {
      offset = be64toh (h->sbuf.sr.payload.error.offset);
      if (offset < cmd->offset || offset >= cmd->offset + cmd->count) {
        SET_NEXT_STATE (STATE_DEAD);
        set_error (0, "offset of error reply is out of bounds, "
                   "offset=%" PRIu64 ", cmd->offset=%" PRIu64 ", "
                   "cmd->count=%" PRIu32 ", "
                   "this is likely to be a bug in the server",
                   offset, cmd->offset, cmd->count);
        return 0;
      }
      if (cmd->type == NBD_CMD_READ &&
          CALLBACK_IS_NOT_NULL (cmd->cb.fn.chunk)) {
        int scratch = error;

        /* Different from successful reads: inform the callback about the
         * current error rather than any earlier one. If the callback fails
         * without setting errno, then use the server's error below.
         */
        if (CALL_CALLBACK (cmd->cb.fn.chunk,
                           cmd->data + (offset - cmd->offset),
                           0, offset, LIBNBD_READ_ERROR,
                           &scratch) == -1)
          if (cmd->error == 0)
            cmd->error = scratch;
      }
    }

    /* Preserve first error encountered */
    if (cmd->error == 0)
      cmd->error = error;

    SET_NEXT_STATE(STATE_REPLY_STRUCTURED_REPLY_FINISH);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_ERROR_TAIL",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA: Receive a structured reply offset-data header */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 321 "generator/states-reply-structured.c"

  struct command *cmd = h->reply_cmd;
  uint64_t offset;
  uint32_t length;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    length = be32toh (h->sbuf.sr.structured_reply.length);
    offset = be64toh (h->sbuf.sr.payload.offset_data.offset);

    assert (cmd); /* guaranteed by CHECK */

    assert (cmd->data && cmd->type == NBD_CMD_READ);
    cmd->data_seen = true;

    /* Length of the data following. */
    length -= 8;

    /* Is the data within bounds? */
    if (offset < cmd->offset) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "offset of reply is out of bounds, "
                 "offset=%" PRIu64 ", cmd->offset=%" PRIu64 ", "
                 "this is likely to be a bug in the server",
                 offset, cmd->offset);
      return 0;
    }
    /* Now this is the byte offset in the read buffer. */
    offset -= cmd->offset;

    if (offset + length > cmd->count) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "offset/length of reply is out of bounds, "
                 "offset=%" PRIu64 ", length=%" PRIu32 ", "
                 "cmd->count=%" PRIu32 ", "
                 "this is likely to be a bug in the server",
                 offset, length, cmd->count);
      return 0;
    }

    /* Set up to receive the data directly to the user buffer. */
    h->rbuf = cmd->data + offset;
    h->rlen = length;
    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA_DATA: Receive a structured reply offset-data block of data */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 373 "generator/states-reply-structured.c"

  struct command *cmd = h->reply_cmd;
  uint64_t offset;
  uint32_t length;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    length = be32toh (h->sbuf.sr.structured_reply.length);
    offset = be64toh (h->sbuf.sr.payload.offset_data.offset);

    assert (cmd); /* guaranteed by CHECK */
    if (CALLBACK_IS_NOT_NULL (cmd->cb.fn.chunk)) {
      int error = cmd->error;

      if (CALL_CALLBACK (cmd->cb.fn.chunk, cmd->data + (offset - cmd->offset),
                         length - sizeof offset, offset,
                         LIBNBD_READ_DATA, &error) == -1)
        if (cmd->error == 0)
          cmd->error = error ? error : EPROTO;
    }

    SET_NEXT_STATE (STATE_REPLY_STRUCTURED_REPLY_FINISH);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA_DATA",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_OFFSET_HOLE: Receive a structured reply offset-hole header */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 403 "generator/states-reply-structured.c"

  struct command *cmd = h->reply_cmd;
  uint64_t offset;
  uint32_t length;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    offset = be64toh (h->sbuf.sr.payload.offset_hole.offset);
    length = be32toh (h->sbuf.sr.payload.offset_hole.length);

    assert (cmd); /* guaranteed by CHECK */

    assert (cmd->data && cmd->type == NBD_CMD_READ);
    cmd->data_seen = true;

    /* Is the data within bounds? */
    if (offset < cmd->offset) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "offset of reply is out of bounds, "
                 "offset=%" PRIu64 ", cmd->offset=%" PRIu64 ", "
                 "this is likely to be a bug in the server",
                 offset, cmd->offset);
      return 0;
    }
    /* Now this is the byte offset in the read buffer. */
    offset -= cmd->offset;

    if (offset + length > cmd->count) {
      SET_NEXT_STATE (STATE_DEAD);
      set_error (0, "offset/length of reply is out of bounds, "
                 "offset=%" PRIu64 ", length=%" PRIu32 ", "
                 "cmd->count=%" PRIu32 ", "
                 "this is likely to be a bug in the server",
                 offset, length, cmd->count);
      return 0;
    }

    /* The spec states that 0-length requests are unspecified, but
     * 0-length replies are broken. Still, it's easy enough to support
     * them as an extension, and this works even when length == 0.
     */
    memset (cmd->data + offset, 0, length);
    if (CALLBACK_IS_NOT_NULL (cmd->cb.fn.chunk)) {
      int error = cmd->error;

      if (CALL_CALLBACK (cmd->cb.fn.chunk,
                         cmd->data + offset, length,
                         cmd->offset + offset,
                         LIBNBD_READ_HOLE, &error) == -1)
        if (cmd->error == 0)
          cmd->error = error ? error : EPROTO;
    }

    SET_NEXT_STATE(STATE_REPLY_STRUCTURED_REPLY_FINISH);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_OFFSET_HOLE",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.RECV_BS_ENTRIES: Receive a structured reply block-status payload */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 465 "generator/states-reply-structured.c"

  struct command *cmd = h->reply_cmd;
  uint32_t length;
  size_t i;
  uint32_t context_id;
  struct meta_context *meta_context;

  switch (recv_into_rbuf (h)) {
  case -1: SET_NEXT_STATE (STATE_DEAD); return 0;
  case 1:
    save_reply_state (h);
    SET_NEXT_STATE (STATE_READY);
    return 0;
  case 0:
    length = be32toh (h->sbuf.sr.structured_reply.length);

    assert (cmd); /* guaranteed by CHECK */
    assert (cmd->type == NBD_CMD_BLOCK_STATUS);
    assert (CALLBACK_IS_NOT_NULL (cmd->cb.fn.extent));
    assert (h->bs_entries);
    assert (length >= 12);

    /* Need to byte-swap the entries returned, but apart from that we
     * don't validate them.
     */
    for (i = 0; i < length/4; ++i)
      h->bs_entries[i] = be32toh (h->bs_entries[i]);

    /* Look up the context ID. */
    context_id = h->bs_entries[0];
    for (meta_context = h->meta_contexts;
         meta_context;
         meta_context = meta_context->next)
      if (context_id == meta_context->context_id)
        break;

    if (meta_context) {
      /* Call the caller's extent function. */
      int error = cmd->error;

      if (CALL_CALLBACK (cmd->cb.fn.extent,
                         meta_context->name, cmd->offset,
                         &h->bs_entries[1], (length-4) / 4,
                         &error) == -1)
        if (cmd->error == 0)
          cmd->error = error ? error : EPROTO;
    }
    else
      /* Emit a debug message, but ignore it. */
      debug (h, "server sent unexpected meta context ID %" PRIu32,
             context_id);

    SET_NEXT_STATE(STATE_REPLY_STRUCTURED_REPLY_FINISH);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.RECV_BS_ENTRIES",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.STRUCTURED_REPLY.FINISH: Finish receiving a structured reply */
static int
_enter_STATE_REPLY_STRUCTURED_REPLY_FINISH (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 521 "generator/states-reply-structured.c"

  uint16_t flags;

  flags = be16toh (h->sbuf.sr.structured_reply.flags);
  if (flags & NBD_REPLY_FLAG_DONE) {
    SET_NEXT_STATE (STATE_REPLY_FINISH_COMMAND);
  }
  else {
    h->reply_cmd = NULL;
    SET_NEXT_STATE (STATE_READY);
  }
  return 0;

}

static int
enter_STATE_REPLY_STRUCTURED_REPLY_FINISH (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_STRUCTURED_REPLY_FINISH;

  r = _enter_STATE_REPLY_STRUCTURED_REPLY_FINISH (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.STRUCTURED_REPLY.FINISH",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* REPLY.FINISH_COMMAND: Finish receiving a command */
static int
_enter_STATE_REPLY_FINISH_COMMAND (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 149 "generator/states-reply.c"

  struct command *prev_cmd, *cmd;
  uint64_t cookie;
  bool retire;

  /* NB: This works for both simple and structured replies because the
   * handle (our cookie) is stored at the same offset.
   */
  cookie = be64toh (h->sbuf.simple_reply.handle);
  /* Find the command amongst the commands in flight. */
  for (cmd = h->cmds_in_flight, prev_cmd = NULL;
       cmd != NULL;
       prev_cmd = cmd, cmd = cmd->next) {
    if (cmd->cookie == cookie)
      break;
  }
  assert (cmd != NULL);
  assert (h->reply_cmd == cmd);
  h->reply_cmd = NULL;
  retire = cmd->type == NBD_CMD_DISC;

  /* Notify the user */
  if (CALLBACK_IS_NOT_NULL (cmd->cb.completion)) {
    int error = cmd->error;
    int r;

    assert (cmd->type != NBD_CMD_DISC);
    r = CALL_CALLBACK (cmd->cb.completion, &error);
    switch (r) {
    case -1:
      if (error)
        cmd->error = error;
      break;
    case 1:
      retire = true;
      break;
    }
  }

  /* Move it to the end of the cmds_done list. */
  if (prev_cmd != NULL)
    prev_cmd->next = cmd->next;
  else
    h->cmds_in_flight = cmd->next;
  cmd->next = NULL;
  if (retire)
    nbd_internal_retire_and_free_command (cmd);
  else {
    if (h->cmds_done_tail != NULL)
      h->cmds_done_tail = h->cmds_done_tail->next = cmd;
    else {
      assert (h->cmds_done == NULL);
      h->cmds_done = h->cmds_done_tail = cmd;
    }
  }
  h->in_flight--;
  assert (h->in_flight >= 0);

  SET_NEXT_STATE (STATE_READY);
  return 0;

}

static int
enter_STATE_REPLY_FINISH_COMMAND (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_REPLY_FINISH_COMMAND;

  r = _enter_STATE_REPLY_FINISH_COMMAND (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "REPLY.FINISH_COMMAND",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* DEAD: Connection is in an unrecoverable error state, can only be closed */
static int
_enter_STATE_DEAD (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 170 "generator/states.c"

  /* The caller should have used set_error() before reaching here */
  assert (nbd_get_error ());
  abort_commands (h, &h->cmds_to_issue);
  abort_commands (h, &h->cmds_in_flight);
  h->in_flight = 0;
  if (h->sock) {
    h->sock->ops->close (h->sock);
    h->sock = NULL;
  }
  return -1;

}

static int
enter_STATE_DEAD (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_DEAD;

  r = _enter_STATE_DEAD (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "DEAD",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* CLOSED: Connection is closed */
static int
_enter_STATE_CLOSED (struct nbd_handle *h,
             enum state *next_state,
             bool *blocked)
{
#line 182 "generator/states.c"

  abort_commands (h, &h->cmds_to_issue);
  abort_commands (h, &h->cmds_in_flight);
  h->in_flight = 0;
  if (h->sock) {
    h->sock->ops->close (h->sock);
    h->sock = NULL;
  }
  return 0;

}

static int
enter_STATE_CLOSED (struct nbd_handle *h, bool *blocked)
{
  int r;
  enum state next_state = STATE_CLOSED;

  r = _enter_STATE_CLOSED (h, &next_state, blocked);
  if (get_next_state (h) != next_state) {
    debug (h, "transition: %s -> %s",
           "CLOSED",
           nbd_internal_state_short_string (next_state));
    set_next_state (h, next_state);
  }
  return r;
}

/* Run the state machine based on an external event until it would block. */
int
nbd_internal_run (struct nbd_handle *h, enum external_event ev)
{
  int r;
  bool blocked;

  /* Validate and handle the external event. */
  switch (get_next_state (h))
  {
  case STATE_START:
    switch (ev)
    {
    case cmd_create:
      goto ok;
    case cmd_connect_sockaddr:
      set_next_state (h, STATE_CONNECT_START);
      debug (h, "event %s: %s -> %s",
             "CmdConnectSockAddr", "START", "CONNECT.START");
      goto ok;
    case cmd_connect_unix:
      set_next_state (h, STATE_CONNECT_UNIX_START);
      debug (h, "event %s: %s -> %s",
             "CmdConnectUnix", "START", "CONNECT_UNIX.START");
      goto ok;
    case cmd_connect_tcp:
      set_next_state (h, STATE_CONNECT_TCP_START);
      debug (h, "event %s: %s -> %s",
             "CmdConnectTCP", "START", "CONNECT_TCP.START");
      goto ok;
    case cmd_connect_command:
      set_next_state (h, STATE_CONNECT_COMMAND_START);
      debug (h, "event %s: %s -> %s",
             "CmdConnectCommand", "START", "CONNECT_COMMAND.START");
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_CONNECT_START:
    switch (ev)
    {
    case notify_write:
      set_next_state (h, STATE_CONNECT_CONNECTING);
      debug (h, "event %s: %s -> %s",
             "NotifyWrite", "CONNECT.START", "CONNECT.CONNECTING");
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_CONNECT_CONNECTING:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_CONNECT_UNIX_START:
    break;
  case STATE_CONNECT_TCP_START:
    break;
  case STATE_CONNECT_TCP_CONNECT:
    switch (ev)
    {
    case notify_write:
      set_next_state (h, STATE_CONNECT_TCP_CONNECTING);
      debug (h, "event %s: %s -> %s",
             "NotifyWrite", "CONNECT_TCP.CONNECT", "CONNECT_TCP.CONNECTING");
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_CONNECT_TCP_CONNECTING:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_CONNECT_TCP_NEXT_ADDRESS:
    break;
  case STATE_CONNECT_COMMAND_START:
    break;
  case STATE_MAGIC_START:
    break;
  case STATE_MAGIC_RECV_MAGIC:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_MAGIC_CHECK_MAGIC:
    break;
  case STATE_OLDSTYLE_START:
    break;
  case STATE_OLDSTYLE_RECV_REMAINING:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_OLDSTYLE_CHECK:
    break;
  case STATE_NEWSTYLE_START:
    break;
  case STATE_NEWSTYLE_RECV_GFLAGS:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_CHECK_GFLAGS:
    break;
  case STATE_NEWSTYLE_SEND_CFLAGS:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_START:
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_SEND:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START:
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_GO_START:
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORT:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_GO_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_START:
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT:
    switch (ev)
    {
    case notify_write:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY:
    switch (ev)
    {
    case notify_read:
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY:
    break;
  case STATE_READY:
    switch (ev)
    {
    case cmd_issue:
      set_next_state (h, STATE_ISSUE_COMMAND_START);
      debug (h, "event %s: %s -> %s",
             "CmdIssue", "READY", "ISSUE_COMMAND.START");
      goto ok;
    case notify_read:
      set_next_state (h, STATE_REPLY_START);
      debug (h, "event %s: %s -> %s",
             "NotifyRead", "READY", "REPLY.START");
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_ISSUE_COMMAND_START:
    break;
  case STATE_ISSUE_COMMAND_SEND_REQUEST:
    switch (ev)
    {
    case notify_write:
      goto ok;
    case notify_read:
      set_next_state (h, STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST);
      debug (h, "event %s: %s -> %s",
             "NotifyRead", "ISSUE_COMMAND.SEND_REQUEST", "ISSUE_COMMAND.PAUSE_SEND_REQUEST");
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST:
    break;
  case STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD:
    break;
  case STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD:
    switch (ev)
    {
    case notify_write:
      goto ok;
    case notify_read:
      set_next_state (h, STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD);
      debug (h, "event %s: %s -> %s",
             "NotifyRead", "ISSUE_COMMAND.SEND_WRITE_PAYLOAD", "ISSUE_COMMAND.PAUSE_WRITE_PAYLOAD");
      goto ok;
    default: ; /* nothing, silence GCC warning */
    }
    break;
  case STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD:
    break;
  case STATE_ISSUE_COMMAND_FINISH:
    break;
  case STATE_REPLY_START:
    break;
  case STATE_REPLY_RECV_REPLY:
    break;
  case STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY:
    break;
  case STATE_REPLY_SIMPLE_REPLY_START:
    break;
  case STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_START:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_CHECK:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_FINISH:
    break;
  case STATE_REPLY_FINISH_COMMAND:
    break;
  case STATE_DEAD:
    break;
  case STATE_CLOSED:
    break;
  }

  set_error (EINVAL, "external event %d is invalid in state %s",
             ev, nbd_internal_state_short_string (get_next_state (h)));
  return -1;

 ok:
  do {
    blocked = true;

    /* Run a single step. */
    switch (get_next_state (h))
    {
    case STATE_START:
      r = enter_STATE_START (h, &blocked);
      break;
    case STATE_CONNECT_START:
      r = enter_STATE_CONNECT_START (h, &blocked);
      break;
    case STATE_CONNECT_CONNECTING:
      r = enter_STATE_CONNECT_CONNECTING (h, &blocked);
      break;
    case STATE_CONNECT_UNIX_START:
      r = enter_STATE_CONNECT_UNIX_START (h, &blocked);
      break;
    case STATE_CONNECT_TCP_START:
      r = enter_STATE_CONNECT_TCP_START (h, &blocked);
      break;
    case STATE_CONNECT_TCP_CONNECT:
      r = enter_STATE_CONNECT_TCP_CONNECT (h, &blocked);
      break;
    case STATE_CONNECT_TCP_CONNECTING:
      r = enter_STATE_CONNECT_TCP_CONNECTING (h, &blocked);
      break;
    case STATE_CONNECT_TCP_NEXT_ADDRESS:
      r = enter_STATE_CONNECT_TCP_NEXT_ADDRESS (h, &blocked);
      break;
    case STATE_CONNECT_COMMAND_START:
      r = enter_STATE_CONNECT_COMMAND_START (h, &blocked);
      break;
    case STATE_MAGIC_START:
      r = enter_STATE_MAGIC_START (h, &blocked);
      break;
    case STATE_MAGIC_RECV_MAGIC:
      r = enter_STATE_MAGIC_RECV_MAGIC (h, &blocked);
      break;
    case STATE_MAGIC_CHECK_MAGIC:
      r = enter_STATE_MAGIC_CHECK_MAGIC (h, &blocked);
      break;
    case STATE_OLDSTYLE_START:
      r = enter_STATE_OLDSTYLE_START (h, &blocked);
      break;
    case STATE_OLDSTYLE_RECV_REMAINING:
      r = enter_STATE_OLDSTYLE_RECV_REMAINING (h, &blocked);
      break;
    case STATE_OLDSTYLE_CHECK:
      r = enter_STATE_OLDSTYLE_CHECK (h, &blocked);
      break;
    case STATE_NEWSTYLE_START:
      r = enter_STATE_NEWSTYLE_START (h, &blocked);
      break;
    case STATE_NEWSTYLE_RECV_GFLAGS:
      r = enter_STATE_NEWSTYLE_RECV_GFLAGS (h, &blocked);
      break;
    case STATE_NEWSTYLE_CHECK_GFLAGS:
      r = enter_STATE_NEWSTYLE_CHECK_GFLAGS (h, &blocked);
      break;
    case STATE_NEWSTYLE_SEND_CFLAGS:
      r = enter_STATE_NEWSTYLE_SEND_CFLAGS (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_START:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_START (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_SEND:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_SEND (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE:
      r = enter_STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START:
      r = enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND:
      r = enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD:
      r = enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_START:
      r = enter_STATE_NEWSTYLE_OPT_GO_START (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_SEND:
      r = enter_STATE_NEWSTYLE_OPT_GO_SEND (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN:
      r = enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_SEND_EXPORT:
      r = enter_STATE_NEWSTYLE_OPT_GO_SEND_EXPORT (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS:
      r = enter_STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_RECV_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD:
      r = enter_STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_GO_CHECK_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_GO_CHECK_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_EXPORT_NAME_START:
      r = enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_START (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND:
      r = enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT:
      r = enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY (h, &blocked);
      break;
    case STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY:
      r = enter_STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY (h, &blocked);
      break;
    case STATE_READY:
      r = enter_STATE_READY (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_START:
      r = enter_STATE_ISSUE_COMMAND_START (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_SEND_REQUEST:
      r = enter_STATE_ISSUE_COMMAND_SEND_REQUEST (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST:
      r = enter_STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD:
      r = enter_STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD:
      r = enter_STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD:
      r = enter_STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD (h, &blocked);
      break;
    case STATE_ISSUE_COMMAND_FINISH:
      r = enter_STATE_ISSUE_COMMAND_FINISH (h, &blocked);
      break;
    case STATE_REPLY_START:
      r = enter_STATE_REPLY_START (h, &blocked);
      break;
    case STATE_REPLY_RECV_REPLY:
      r = enter_STATE_REPLY_RECV_REPLY (h, &blocked);
      break;
    case STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY:
      r = enter_STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY (h, &blocked);
      break;
    case STATE_REPLY_SIMPLE_REPLY_START:
      r = enter_STATE_REPLY_SIMPLE_REPLY_START (h, &blocked);
      break;
    case STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD:
      r = enter_STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_START:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_START (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_CHECK:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_CHECK (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES (h, &blocked);
      break;
    case STATE_REPLY_STRUCTURED_REPLY_FINISH:
      r = enter_STATE_REPLY_STRUCTURED_REPLY_FINISH (h, &blocked);
      break;
    case STATE_REPLY_FINISH_COMMAND:
      r = enter_STATE_REPLY_FINISH_COMMAND (h, &blocked);
      break;
    case STATE_DEAD:
      r = enter_STATE_DEAD (h, &blocked);
      break;
    case STATE_CLOSED:
      r = enter_STATE_CLOSED (h, &blocked);
      break;
    default:
      abort (); /* Should never happen, but keeps GCC happy. */
    }

    if (r == -1) {
      assert (nbd_get_error () != NULL);
      return -1;
    }
  } while (!blocked);
  return 0;
}

/* Returns whether in the given state read or write would be valid.
 * NB: is_locked = false, may_set_error = false.
 */
int
nbd_internal_aio_get_direction (enum state state)
{
  int r = 0;

  switch (state)
  {
  case STATE_START:
    break;
  case STATE_CONNECT_START:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_CONNECT_CONNECTING:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_CONNECT_UNIX_START:
    break;
  case STATE_CONNECT_TCP_START:
    break;
  case STATE_CONNECT_TCP_CONNECT:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_CONNECT_TCP_CONNECTING:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_CONNECT_TCP_NEXT_ADDRESS:
    break;
  case STATE_CONNECT_COMMAND_START:
    break;
  case STATE_MAGIC_START:
    break;
  case STATE_MAGIC_RECV_MAGIC:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_MAGIC_CHECK_MAGIC:
    break;
  case STATE_OLDSTYLE_START:
    break;
  case STATE_OLDSTYLE_RECV_REMAINING:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_OLDSTYLE_CHECK:
    break;
  case STATE_NEWSTYLE_START:
    break;
  case STATE_NEWSTYLE_RECV_GFLAGS:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_CHECK_GFLAGS:
    break;
  case STATE_NEWSTYLE_SEND_CFLAGS:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_START:
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_SEND:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START:
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_GO_START:
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORT:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_GO_CHECK_REPLY:
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_START:
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY:
    break;
  case STATE_READY:
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_ISSUE_COMMAND_START:
    break;
  case STATE_ISSUE_COMMAND_SEND_REQUEST:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST:
    break;
  case STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD:
    break;
  case STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD:
    r |= LIBNBD_AIO_DIRECTION_WRITE;
    r |= LIBNBD_AIO_DIRECTION_READ;
    break;
  case STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD:
    break;
  case STATE_ISSUE_COMMAND_FINISH:
    break;
  case STATE_REPLY_START:
    break;
  case STATE_REPLY_RECV_REPLY:
    break;
  case STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY:
    break;
  case STATE_REPLY_SIMPLE_REPLY_START:
    break;
  case STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_START:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_CHECK:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES:
    break;
  case STATE_REPLY_STRUCTURED_REPLY_FINISH:
    break;
  case STATE_REPLY_FINISH_COMMAND:
    break;
  case STATE_DEAD:
    break;
  case STATE_CLOSED:
    break;
  }

  return r;
}

/* Other functions associated with the state machine. */
const char *
nbd_internal_state_short_string (enum state state)
{
  switch (state)
  {
  case STATE_START:
    return "START";
  case STATE_CONNECT_START:
    return "CONNECT.START";
  case STATE_CONNECT_CONNECTING:
    return "CONNECT.CONNECTING";
  case STATE_CONNECT_UNIX_START:
    return "CONNECT_UNIX.START";
  case STATE_CONNECT_TCP_START:
    return "CONNECT_TCP.START";
  case STATE_CONNECT_TCP_CONNECT:
    return "CONNECT_TCP.CONNECT";
  case STATE_CONNECT_TCP_CONNECTING:
    return "CONNECT_TCP.CONNECTING";
  case STATE_CONNECT_TCP_NEXT_ADDRESS:
    return "CONNECT_TCP.NEXT_ADDRESS";
  case STATE_CONNECT_COMMAND_START:
    return "CONNECT_COMMAND.START";
  case STATE_MAGIC_START:
    return "MAGIC.START";
  case STATE_MAGIC_RECV_MAGIC:
    return "MAGIC.RECV_MAGIC";
  case STATE_MAGIC_CHECK_MAGIC:
    return "MAGIC.CHECK_MAGIC";
  case STATE_OLDSTYLE_START:
    return "OLDSTYLE.START";
  case STATE_OLDSTYLE_RECV_REMAINING:
    return "OLDSTYLE.RECV_REMAINING";
  case STATE_OLDSTYLE_CHECK:
    return "OLDSTYLE.CHECK";
  case STATE_NEWSTYLE_START:
    return "NEWSTYLE.START";
  case STATE_NEWSTYLE_RECV_GFLAGS:
    return "NEWSTYLE.RECV_GFLAGS";
  case STATE_NEWSTYLE_CHECK_GFLAGS:
    return "NEWSTYLE.CHECK_GFLAGS";
  case STATE_NEWSTYLE_SEND_CFLAGS:
    return "NEWSTYLE.SEND_CFLAGS";
  case STATE_NEWSTYLE_OPT_STARTTLS_START:
    return "NEWSTYLE.OPT_STARTTLS.START";
  case STATE_NEWSTYLE_OPT_STARTTLS_SEND:
    return "NEWSTYLE.OPT_STARTTLS.SEND";
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY:
    return "NEWSTYLE.OPT_STARTTLS.RECV_REPLY";
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_STARTTLS.RECV_REPLY_PAYLOAD";
  case STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY:
    return "NEWSTYLE.OPT_STARTTLS.CHECK_REPLY";
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ:
    return "NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_READ";
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE:
    return "NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_WRITE";
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.START";
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.SEND";
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY";
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY_PAYLOAD";
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.CHECK_REPLY";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.START";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAMELEN";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAME";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_NRQUERIES";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_NEXT_QUERY";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERYLEN";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERY";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_FOR_REPLY";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY_PAYLOAD";
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.CHECK_REPLY";
  case STATE_NEWSTYLE_OPT_GO_START:
    return "NEWSTYLE.OPT_GO.START";
  case STATE_NEWSTYLE_OPT_GO_SEND:
    return "NEWSTYLE.OPT_GO.SEND";
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN:
    return "NEWSTYLE.OPT_GO.SEND_EXPORTNAMELEN";
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORT:
    return "NEWSTYLE.OPT_GO.SEND_EXPORT";
  case STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS:
    return "NEWSTYLE.OPT_GO.SEND_NRINFOS";
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY:
    return "NEWSTYLE.OPT_GO.RECV_REPLY";
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_GO.RECV_REPLY_PAYLOAD";
  case STATE_NEWSTYLE_OPT_GO_CHECK_REPLY:
    return "NEWSTYLE.OPT_GO.CHECK_REPLY";
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_START:
    return "NEWSTYLE.OPT_EXPORT_NAME.START";
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND:
    return "NEWSTYLE.OPT_EXPORT_NAME.SEND";
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT:
    return "NEWSTYLE.OPT_EXPORT_NAME.SEND_EXPORT";
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY:
    return "NEWSTYLE.OPT_EXPORT_NAME.RECV_REPLY";
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY:
    return "NEWSTYLE.OPT_EXPORT_NAME.CHECK_REPLY";
  case STATE_READY:
    return "READY";
  case STATE_ISSUE_COMMAND_START:
    return "ISSUE_COMMAND.START";
  case STATE_ISSUE_COMMAND_SEND_REQUEST:
    return "ISSUE_COMMAND.SEND_REQUEST";
  case STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST:
    return "ISSUE_COMMAND.PAUSE_SEND_REQUEST";
  case STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD:
    return "ISSUE_COMMAND.PREPARE_WRITE_PAYLOAD";
  case STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD:
    return "ISSUE_COMMAND.SEND_WRITE_PAYLOAD";
  case STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD:
    return "ISSUE_COMMAND.PAUSE_WRITE_PAYLOAD";
  case STATE_ISSUE_COMMAND_FINISH:
    return "ISSUE_COMMAND.FINISH";
  case STATE_REPLY_START:
    return "REPLY.START";
  case STATE_REPLY_RECV_REPLY:
    return "REPLY.RECV_REPLY";
  case STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY:
    return "REPLY.CHECK_SIMPLE_OR_STRUCTURED_REPLY";
  case STATE_REPLY_SIMPLE_REPLY_START:
    return "REPLY.SIMPLE_REPLY.START";
  case STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD:
    return "REPLY.SIMPLE_REPLY.RECV_READ_PAYLOAD";
  case STATE_REPLY_STRUCTURED_REPLY_START:
    return "REPLY.STRUCTURED_REPLY.START";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING:
    return "REPLY.STRUCTURED_REPLY.RECV_REMAINING";
  case STATE_REPLY_STRUCTURED_REPLY_CHECK:
    return "REPLY.STRUCTURED_REPLY.CHECK";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR:
    return "REPLY.STRUCTURED_REPLY.RECV_ERROR";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE:
    return "REPLY.STRUCTURED_REPLY.RECV_ERROR_MESSAGE";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL:
    return "REPLY.STRUCTURED_REPLY.RECV_ERROR_TAIL";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA:
    return "REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA:
    return "REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA_DATA";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE:
    return "REPLY.STRUCTURED_REPLY.RECV_OFFSET_HOLE";
  case STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES:
    return "REPLY.STRUCTURED_REPLY.RECV_BS_ENTRIES";
  case STATE_REPLY_STRUCTURED_REPLY_FINISH:
    return "REPLY.STRUCTURED_REPLY.FINISH";
  case STATE_REPLY_FINISH_COMMAND:
    return "REPLY.FINISH_COMMAND";
  case STATE_DEAD:
    return "DEAD";
  case STATE_CLOSED:
    return "CLOSED";
  }

  /* This function is only used for debug messages, and
   * this should never happen.
   */
  return "UNKNOWN!";
}

const char *
nbd_unlocked_connection_state (struct nbd_handle *h)
{
  switch (get_next_state (h))
  {
  case STATE_START:
    return "START" ": "
           "Handle after being initially created";

  case STATE_CONNECT_START:
    return "CONNECT.START" ": "
           "Initial call to connect(2) on the socket";

  case STATE_CONNECT_CONNECTING:
    return "CONNECT.CONNECTING" ": "
           "Connecting to the remote server";

  case STATE_CONNECT_UNIX_START:
    return "CONNECT_UNIX.START" ": "
           "Connect to a Unix domain socket";

  case STATE_CONNECT_TCP_START:
    return "CONNECT_TCP.START" ": "
           "Connect to a remote TCP server";

  case STATE_CONNECT_TCP_CONNECT:
    return "CONNECT_TCP.CONNECT" ": "
           "Initial call to connect(2) on a TCP socket";

  case STATE_CONNECT_TCP_CONNECTING:
    return "CONNECT_TCP.CONNECTING" ": "
           "Connecting to the remote server over a TCP socket";

  case STATE_CONNECT_TCP_NEXT_ADDRESS:
    return "CONNECT_TCP.NEXT_ADDRESS" ": "
           "Connecting to the next address over a TCP socket";

  case STATE_CONNECT_COMMAND_START:
    return "CONNECT_COMMAND.START" ": "
           "Connect to a subprocess";

  case STATE_MAGIC_START:
    return "MAGIC.START" ": "
           "Prepare to receive the magic identification from remote";

  case STATE_MAGIC_RECV_MAGIC:
    return "MAGIC.RECV_MAGIC" ": "
           "Receive initial magic identification from remote";

  case STATE_MAGIC_CHECK_MAGIC:
    return "MAGIC.CHECK_MAGIC" ": "
           "Check magic and version sent by remote";

  case STATE_OLDSTYLE_START:
    return "OLDSTYLE.START" ": "
           "Prepare to receive remainder of oldstyle header";

  case STATE_OLDSTYLE_RECV_REMAINING:
    return "OLDSTYLE.RECV_REMAINING" ": "
           "Receive remainder of oldstyle header";

  case STATE_OLDSTYLE_CHECK:
    return "OLDSTYLE.CHECK" ": "
           "Check oldstyle header";

  case STATE_NEWSTYLE_START:
    return "NEWSTYLE.START" ": "
           "Prepare to receive newstyle gflags from remote";

  case STATE_NEWSTYLE_RECV_GFLAGS:
    return "NEWSTYLE.RECV_GFLAGS" ": "
           "Receive newstyle gflags from remote";

  case STATE_NEWSTYLE_CHECK_GFLAGS:
    return "NEWSTYLE.CHECK_GFLAGS" ": "
           "Check global flags sent by remote";

  case STATE_NEWSTYLE_SEND_CFLAGS:
    return "NEWSTYLE.SEND_CFLAGS" ": "
           "Send newstyle client flags to remote";

  case STATE_NEWSTYLE_OPT_STARTTLS_START:
    return "NEWSTYLE.OPT_STARTTLS.START" ": "
           "Try to send newstyle NBD_OPT_STARTTLS to upgrade to TLS";

  case STATE_NEWSTYLE_OPT_STARTTLS_SEND:
    return "NEWSTYLE.OPT_STARTTLS.SEND" ": "
           "Send newstyle NBD_OPT_STARTTLS to upgrade to TLS";

  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY:
    return "NEWSTYLE.OPT_STARTTLS.RECV_REPLY" ": "
           "Receive newstyle NBD_OPT_STARTTLS reply";

  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_STARTTLS.RECV_REPLY_PAYLOAD" ": "
           "Receive any newstyle NBD_OPT_STARTTLS reply payload";

  case STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY:
    return "NEWSTYLE.OPT_STARTTLS.CHECK_REPLY" ": "
           "Check newstyle NBD_OPT_STARTTLS reply";

  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ:
    return "NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_READ" ": "
           "TLS handshake (reading)";

  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE:
    return "NEWSTYLE.OPT_STARTTLS.TLS_HANDSHAKE_WRITE" ": "
           "TLS handshake (writing)";

  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.START" ": "
           "Try to negotiate newstyle NBD_OPT_STRUCTURED_REPLY";

  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.SEND" ": "
           "Send newstyle NBD_OPT_STRUCTURED_REPLY negotiation request";

  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY" ": "
           "Receive newstyle NBD_OPT_STRUCTURED_REPLY option reply";

  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.RECV_REPLY_PAYLOAD" ": "
           "Receive any newstyle NBD_OPT_STRUCTURED_REPLY reply payload";

  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY:
    return "NEWSTYLE.OPT_STRUCTURED_REPLY.CHECK_REPLY" ": "
           "Check newstyle NBD_OPT_STRUCTURED_REPLY option reply";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.START" ": "
           "Try to negotiate newstyle NBD_OPT_SET_META_CONTEXT";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND" ": "
           "Send newstyle NBD_OPT_SET_META_CONTEXT";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAMELEN" ": "
           "Send newstyle NBD_OPT_SET_META_CONTEXT export name length";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_EXPORTNAME" ": "
           "Send newstyle NBD_OPT_SET_META_CONTEXT export name";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_NRQUERIES" ": "
           "Send newstyle NBD_OPT_SET_META_CONTEXT number of queries";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_NEXT_QUERY" ": "
           "Prepare to send newstyle NBD_OPT_SET_META_CONTEXT query";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERYLEN" ": "
           "Send newstyle NBD_OPT_SET_META_CONTEXT query length";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.SEND_QUERY" ": "
           "Send newstyle NBD_OPT_SET_META_CONTEXT query";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.PREPARE_FOR_REPLY" ": "
           "Prepare to receive newstyle NBD_OPT_SET_META_CONTEXT option reply";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY" ": "
           "Receive newstyle NBD_OPT_SET_META_CONTEXT option reply";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.RECV_REPLY_PAYLOAD" ": "
           "Receive newstyle NBD_OPT_SET_META_CONTEXT option reply payload";

  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY:
    return "NEWSTYLE.OPT_SET_META_CONTEXT.CHECK_REPLY" ": "
           "Check newstyle NBD_OPT_SET_META_CONTEXT option reply";

  case STATE_NEWSTYLE_OPT_GO_START:
    return "NEWSTYLE.OPT_GO.START" ": "
           "Try to send newstyle NBD_OPT_GO to end handshake";

  case STATE_NEWSTYLE_OPT_GO_SEND:
    return "NEWSTYLE.OPT_GO.SEND" ": "
           "Send newstyle NBD_OPT_GO to end handshake";

  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN:
    return "NEWSTYLE.OPT_GO.SEND_EXPORTNAMELEN" ": "
           "Send newstyle NBD_OPT_GO export name length";

  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORT:
    return "NEWSTYLE.OPT_GO.SEND_EXPORT" ": "
           "Send newstyle NBD_OPT_GO export name";

  case STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS:
    return "NEWSTYLE.OPT_GO.SEND_NRINFOS" ": "
           "Send newstyle NBD_OPT_GO number of infos";

  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY:
    return "NEWSTYLE.OPT_GO.RECV_REPLY" ": "
           "Receive newstyle NBD_OPT_GO reply";

  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD:
    return "NEWSTYLE.OPT_GO.RECV_REPLY_PAYLOAD" ": "
           "Receive newstyle NBD_OPT_GO reply payload";

  case STATE_NEWSTYLE_OPT_GO_CHECK_REPLY:
    return "NEWSTYLE.OPT_GO.CHECK_REPLY" ": "
           "Check newstyle NBD_OPT_GO reply";

  case STATE_NEWSTYLE_OPT_EXPORT_NAME_START:
    return "NEWSTYLE.OPT_EXPORT_NAME.START" ": "
           "Try to send newstyle NBD_OPT_EXPORT_NAME to end handshake";

  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND:
    return "NEWSTYLE.OPT_EXPORT_NAME.SEND" ": "
           "Send newstyle NBD_OPT_EXPORT_NAME to end handshake";

  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT:
    return "NEWSTYLE.OPT_EXPORT_NAME.SEND_EXPORT" ": "
           "Send newstyle NBD_OPT_EXPORT_NAME export name";

  case STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY:
    return "NEWSTYLE.OPT_EXPORT_NAME.RECV_REPLY" ": "
           "Receive newstyle NBD_OPT_EXPORT_NAME reply";

  case STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY:
    return "NEWSTYLE.OPT_EXPORT_NAME.CHECK_REPLY" ": "
           "Check newstyle NBD_OPT_EXPORT_NAME reply";

  case STATE_READY:
    return "READY" ": "
           "Connection is ready to process NBD commands";

  case STATE_ISSUE_COMMAND_START:
    return "ISSUE_COMMAND.START" ": "
           "Begin issuing a command to the remote server";

  case STATE_ISSUE_COMMAND_SEND_REQUEST:
    return "ISSUE_COMMAND.SEND_REQUEST" ": "
           "Sending a request to the remote server";

  case STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST:
    return "ISSUE_COMMAND.PAUSE_SEND_REQUEST" ": "
           "Interrupt send request to receive an earlier command's reply";

  case STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD:
    return "ISSUE_COMMAND.PREPARE_WRITE_PAYLOAD" ": "
           "Prepare the write payload to send to the remote server";

  case STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD:
    return "ISSUE_COMMAND.SEND_WRITE_PAYLOAD" ": "
           "Sending the write payload to the remote server";

  case STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD:
    return "ISSUE_COMMAND.PAUSE_WRITE_PAYLOAD" ": "
           "Interrupt write payload to receive an earlier command's reply";

  case STATE_ISSUE_COMMAND_FINISH:
    return "ISSUE_COMMAND.FINISH" ": "
           "Finish issuing a command";

  case STATE_REPLY_START:
    return "REPLY.START" ": "
           "Prepare to receive a reply from the remote server";

  case STATE_REPLY_RECV_REPLY:
    return "REPLY.RECV_REPLY" ": "
           "Receive a reply from the remote server";

  case STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY:
    return "REPLY.CHECK_SIMPLE_OR_STRUCTURED_REPLY" ": "
           "Check if the reply is a simple or structured reply";

  case STATE_REPLY_SIMPLE_REPLY_START:
    return "REPLY.SIMPLE_REPLY.START" ": "
           "Parse a simple reply from the server";

  case STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD:
    return "REPLY.SIMPLE_REPLY.RECV_READ_PAYLOAD" ": "
           "Receiving the read payload for a simple reply";

  case STATE_REPLY_STRUCTURED_REPLY_START:
    return "REPLY.STRUCTURED_REPLY.START" ": "
           "Prepare to receive the remaining part of a structured reply";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING:
    return "REPLY.STRUCTURED_REPLY.RECV_REMAINING" ": "
           "Receiving the remaining part of a structured reply";

  case STATE_REPLY_STRUCTURED_REPLY_CHECK:
    return "REPLY.STRUCTURED_REPLY.CHECK" ": "
           "Parse a structured reply from the server";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR:
    return "REPLY.STRUCTURED_REPLY.RECV_ERROR" ": "
           "Receive a structured reply error header";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE:
    return "REPLY.STRUCTURED_REPLY.RECV_ERROR_MESSAGE" ": "
           "Receive a structured reply error message";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL:
    return "REPLY.STRUCTURED_REPLY.RECV_ERROR_TAIL" ": "
           "Receive a structured reply error tail";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA:
    return "REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA" ": "
           "Receive a structured reply offset-data header";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA:
    return "REPLY.STRUCTURED_REPLY.RECV_OFFSET_DATA_DATA" ": "
           "Receive a structured reply offset-data block of data";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE:
    return "REPLY.STRUCTURED_REPLY.RECV_OFFSET_HOLE" ": "
           "Receive a structured reply offset-hole header";

  case STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES:
    return "REPLY.STRUCTURED_REPLY.RECV_BS_ENTRIES" ": "
           "Receive a structured reply block-status payload";

  case STATE_REPLY_STRUCTURED_REPLY_FINISH:
    return "REPLY.STRUCTURED_REPLY.FINISH" ": "
           "Finish receiving a structured reply";

  case STATE_REPLY_FINISH_COMMAND:
    return "REPLY.FINISH_COMMAND" ": "
           "Finish receiving a command";

  case STATE_DEAD:
    return "DEAD" ": "
           "Connection is in an unrecoverable error state, can only be closed";

  case STATE_CLOSED:
    return "CLOSED" ": "
           "Connection is closed";

  }

  return NULL;
}

/* Map a state to its group name. */
enum state_group
nbd_internal_state_group (enum state state)
{
  switch (state) {
  case STATE_START:
    return GROUP_TOP;
  case STATE_CONNECT_START:
    return GROUP_CONNECT;
  case STATE_CONNECT_CONNECTING:
    return GROUP_CONNECT;
  case STATE_CONNECT_UNIX_START:
    return GROUP_CONNECT_UNIX;
  case STATE_CONNECT_TCP_START:
    return GROUP_CONNECT_TCP;
  case STATE_CONNECT_TCP_CONNECT:
    return GROUP_CONNECT_TCP;
  case STATE_CONNECT_TCP_CONNECTING:
    return GROUP_CONNECT_TCP;
  case STATE_CONNECT_TCP_NEXT_ADDRESS:
    return GROUP_CONNECT_TCP;
  case STATE_CONNECT_COMMAND_START:
    return GROUP_CONNECT_COMMAND;
  case STATE_MAGIC_START:
    return GROUP_MAGIC;
  case STATE_MAGIC_RECV_MAGIC:
    return GROUP_MAGIC;
  case STATE_MAGIC_CHECK_MAGIC:
    return GROUP_MAGIC;
  case STATE_OLDSTYLE_START:
    return GROUP_OLDSTYLE;
  case STATE_OLDSTYLE_RECV_REMAINING:
    return GROUP_OLDSTYLE;
  case STATE_OLDSTYLE_CHECK:
    return GROUP_OLDSTYLE;
  case STATE_NEWSTYLE_START:
    return GROUP_NEWSTYLE;
  case STATE_NEWSTYLE_RECV_GFLAGS:
    return GROUP_NEWSTYLE;
  case STATE_NEWSTYLE_CHECK_GFLAGS:
    return GROUP_NEWSTYLE;
  case STATE_NEWSTYLE_SEND_CFLAGS:
    return GROUP_NEWSTYLE;
  case STATE_NEWSTYLE_OPT_STARTTLS_START:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STARTTLS_SEND:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STARTTLS_RECV_REPLY_PAYLOAD:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STARTTLS_CHECK_REPLY:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_READ:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STARTTLS_TLS_HANDSHAKE_WRITE:
    return GROUP_NEWSTYLE_OPT_STARTTLS;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_START:
    return GROUP_NEWSTYLE_OPT_STRUCTURED_REPLY;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_SEND:
    return GROUP_NEWSTYLE_OPT_STRUCTURED_REPLY;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY:
    return GROUP_NEWSTYLE_OPT_STRUCTURED_REPLY;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_RECV_REPLY_PAYLOAD:
    return GROUP_NEWSTYLE_OPT_STRUCTURED_REPLY;
  case STATE_NEWSTYLE_OPT_STRUCTURED_REPLY_CHECK_REPLY:
    return GROUP_NEWSTYLE_OPT_STRUCTURED_REPLY;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_START:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAMELEN:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_EXPORTNAME:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_NRQUERIES:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_NEXT_QUERY:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERYLEN:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_SEND_QUERY:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_PREPARE_FOR_REPLY:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_RECV_REPLY_PAYLOAD:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_SET_META_CONTEXT_CHECK_REPLY:
    return GROUP_NEWSTYLE_OPT_SET_META_CONTEXT;
  case STATE_NEWSTYLE_OPT_GO_START:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_SEND:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORTNAMELEN:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_SEND_EXPORT:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_SEND_NRINFOS:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_RECV_REPLY_PAYLOAD:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_GO_CHECK_REPLY:
    return GROUP_NEWSTYLE_OPT_GO;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_START:
    return GROUP_NEWSTYLE_OPT_EXPORT_NAME;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND:
    return GROUP_NEWSTYLE_OPT_EXPORT_NAME;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_SEND_EXPORT:
    return GROUP_NEWSTYLE_OPT_EXPORT_NAME;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_RECV_REPLY:
    return GROUP_NEWSTYLE_OPT_EXPORT_NAME;
  case STATE_NEWSTYLE_OPT_EXPORT_NAME_CHECK_REPLY:
    return GROUP_NEWSTYLE_OPT_EXPORT_NAME;
  case STATE_READY:
    return GROUP_TOP;
  case STATE_ISSUE_COMMAND_START:
    return GROUP_ISSUE_COMMAND;
  case STATE_ISSUE_COMMAND_SEND_REQUEST:
    return GROUP_ISSUE_COMMAND;
  case STATE_ISSUE_COMMAND_PAUSE_SEND_REQUEST:
    return GROUP_ISSUE_COMMAND;
  case STATE_ISSUE_COMMAND_PREPARE_WRITE_PAYLOAD:
    return GROUP_ISSUE_COMMAND;
  case STATE_ISSUE_COMMAND_SEND_WRITE_PAYLOAD:
    return GROUP_ISSUE_COMMAND;
  case STATE_ISSUE_COMMAND_PAUSE_WRITE_PAYLOAD:
    return GROUP_ISSUE_COMMAND;
  case STATE_ISSUE_COMMAND_FINISH:
    return GROUP_ISSUE_COMMAND;
  case STATE_REPLY_START:
    return GROUP_REPLY;
  case STATE_REPLY_RECV_REPLY:
    return GROUP_REPLY;
  case STATE_REPLY_CHECK_SIMPLE_OR_STRUCTURED_REPLY:
    return GROUP_REPLY;
  case STATE_REPLY_SIMPLE_REPLY_START:
    return GROUP_REPLY_SIMPLE_REPLY;
  case STATE_REPLY_SIMPLE_REPLY_RECV_READ_PAYLOAD:
    return GROUP_REPLY_SIMPLE_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_START:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_REMAINING:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_CHECK:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_MESSAGE:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_ERROR_TAIL:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_DATA_DATA:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_OFFSET_HOLE:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_RECV_BS_ENTRIES:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_STRUCTURED_REPLY_FINISH:
    return GROUP_REPLY_STRUCTURED_REPLY;
  case STATE_REPLY_FINISH_COMMAND:
    return GROUP_REPLY;
  case STATE_DEAD:
    return GROUP_TOP;
  case STATE_CLOSED:
    return GROUP_TOP;
  default:
    abort (); /* Should never happen, but keeps GCC happy. */
  }
}

/* Map a state group to its parent group. */
enum state_group
nbd_internal_state_group_parent (enum state_group group)
{
  switch (group) {
  case GROUP_TOP:
    return GROUP_TOP;
  case GROUP_CONNECT:
    return GROUP_TOP;
  case GROUP_CONNECT_UNIX:
    return GROUP_TOP;
  case GROUP_CONNECT_TCP:
    return GROUP_TOP;
  case GROUP_CONNECT_COMMAND:
    return GROUP_TOP;
  case GROUP_MAGIC:
    return GROUP_TOP;
  case GROUP_OLDSTYLE:
    return GROUP_TOP;
  case GROUP_NEWSTYLE:
    return GROUP_TOP;
  case GROUP_NEWSTYLE_OPT_STARTTLS:
    return GROUP_NEWSTYLE;
  case GROUP_NEWSTYLE_OPT_STRUCTURED_REPLY:
    return GROUP_NEWSTYLE;
  case GROUP_NEWSTYLE_OPT_SET_META_CONTEXT:
    return GROUP_NEWSTYLE;
  case GROUP_NEWSTYLE_OPT_GO:
    return GROUP_NEWSTYLE;
  case GROUP_NEWSTYLE_OPT_EXPORT_NAME:
    return GROUP_NEWSTYLE;
  case GROUP_ISSUE_COMMAND:
    return GROUP_TOP;
  case GROUP_REPLY:
    return GROUP_TOP;
  case GROUP_REPLY_SIMPLE_REPLY:
    return GROUP_REPLY;
  case GROUP_REPLY_STRUCTURED_REPLY:
    return GROUP_REPLY;
  default:
    abort (); /* Should never happen, but keeps GCC happy. */
  }
};
